local sproto = require "3rd/sproto/sproto"
local battlemessage = {}
local var = {
    session_id = 0 ,
    session = {},
    object = {},
}

function battlemessage.register()	
	local s2c = require "3rd/sproto/protos/room_sc"
	var.host = sproto.parse(s2c):host "package"
	local c2s = require "3rd/sproto/protos/room_cs"
	var.request = var.host:attach(sproto.parse(c2s))
	log("battlemessage.register.....")
end

function battlemessage.bind(obj, handler)
    var.object[obj] = handler
end

function battlemessage.request(name, args)
    var.session_id = var.session_id + 1
    var.session[var.session_id] = { name = name, req = args }
    local msg = var.request(name , args, var.session_id)

	local buffer = ByteBuffer.New();
	buffer:WriteUnShortBuffer(msg); -- WriteBuffer WriteUnShortBuffer
	networkMgr:SendBattleMessage(buffer);
    
    return var.session_id
end

function battlemessage.receive(buffer)
	
	local msg = buffer:ReadShortBuffer();
	
    if not msg then
        return false
    end

    local t, session_id, resp, err = var.host:dispatch(msg) --val
    if t == "REQUEST" then
        for obj, handler in pairs(var.object) do
            local f = handler[session_id]	-- session_id is request type
            if f then
                local ok, err_msg = pcall(f, obj, resp)	-- resp is content of push
                if not ok then
                    print(string.format("push %s for [%s] error : %s", session_id, tostring(obj), err_msg))
                end
            end
        end
    else
        local session = var.session[session_id]
        var.session[session_id] = nil
        for obj, handler in pairs(var.object) do
            if err then
                local f = handler.__error
                if f then
                    local ok, err_msg = pcall(f, obj, session.name, err, session.req, session_id)
                    if not ok then
                        print(string.format("session %s[%d] error(%s) for [%s] error : %s", session.name, session_id, err, tostring(obj), err_msg))
                    end
                end
            else
                local f = handler[session.name]
                if f then
                    local ok, err_msg = pcall(f, obj, session.req, resp, session_id)
                    if not ok then
                        print(string.format("session %s[%d] for [%s] error : %s", session.name, session_id, tostring(obj), err_msg))
                    end
                end
            end
        end
    end

    return true
end

return battlemessage