local spevent = {}

function spevent:__error(what, err, req, session)
    print("error", what, err)
end

-- 游戏服务器登录返回
function spevent:user_login(_, resp) -- user_login
    print("global_login ok....");
	
	Network.Start_Ping();
	AppConst.iSwitchUser = false;
	reconnetCount = 1;

	networkMgr:ShowLoading(false);
	
	if DataEntry.roleModel.SceneId > 1 then
		logWarn("in battle scene.............");
	else
		LoginCtrl.Close();
		
		if loadCount > 1 then
			Network.ShowSystemMessage(2,false);
			AvatarManager.Instance:InitMyAvatar(false)
		end
		
		if resp.created then
			Network.SendPlayerInfo();
			Network.SendBoxGetList();
			Network.SendSevenDayData();
			-- 打开主ui
			Network.AwakePanel(CtrlNames.Main);
		else
			Network.AwakePanel(CtrlNames.CharaCreation);
		end
		
		Network.SendRoomServer();
	end

end

-- 游戏房间列表返回
function spevent:global_roomserver(_, resp)
    print("global_roomserver ok....")

	-- MainCtrl.GetHosts(resp.hosts)
	local ips = resp.hosts;
		
	local item = ips[1]
	local splitlist1 = {}
	string.gsub(item.addr, '[^:]+', function(w) table.insert(splitlist1, w) end )
	log("ip runtime:ip:"..splitlist1[1])
	
	AppConst.SocketBattleAddress = splitlist1[1];
	--networkMgr:SendBattleConnect()
end

-- 游戏房间列表返回
function spevent:global_ping(_, resp)
    --log("global_ping servertime:"..tostring(resp.servertime))

    MainCtrl.GetServerTime(resp.servertime);
end

-- 游戏结果返回
function spevent:user_pvpresult(_, resp)
    log("user_pvpresult code:"..tostring(resp.code));
end

-- 游戏个人信息返回
function spevent:user_info(_, resp)
	log("user info ok.....");
	local _level = tostring(resp.level);
	networkMgr:LogSelectServer(_level,"1");
	MainCtrl.InitPlayerInfo(resp);
end	

-- 更新个人信息返回 --
function spevent:update_user_info(resp)
	log("update user info....");
	--local _level = resp.level;
	--[[sex 2 : integer
	level 3 : integer
	exp 4 : integer
	gem 5 : integer
	gold 6 : integer
	gembonus 7 : integer
	gemtotalpaid 8 : integer
	diamond 9 : integer
	total_round 10 : integer
	win_round 11 : integer
	total_kill 12 : integer
	total_dead 13 : integer
	total_damage 14 : integer
	total_injure 15 : integer
	weapons 16 : *WeaponInfo
	role_skin 17 : *RoleSkinInfo
	favorate_weapon 18 : integer  #最爱武器proto_id
	total_assists 19 : integer--]]
	
	if resp.gold ~= nil then
		PlayerInfo.gold = resp.gold;
		DataEntry.roleModel.Gold = resp.gold;
		MainCtrl.UpdataPlayerInfoUI();
	end
	
	if resp.weapons ~= nil then
		if next(resp.weapons) then
			PlayerInfo.weapons = resp.weapons;
		end
	end
	
	
end

-- 游戏角色创建返回
function spevent:user_create(_, resp)
	log("user create ok.....");
	networkMgr:ShowLoading(false);
	-- # 0:成功 1:昵称长度不符合要求 2:昵称含有非法字符 3:该昵称已存在 4:不能重复创建角色 5:创建失败（内部错误）
	if resp.code == 0 then
		-- 打开主ui
		Network.SendPlayerInfo();
		Network.SendSevenDayData();
		CharaCreationCtrl.Close();
		Network.AwakePanel(CtrlNames.Main);
		networkMgr:LogCreateRole(resp.userid,resp.nickname,"1","1");
	else
		-- 提示错误信息
		logWarn("user_create<<code:"..resp.code);
		local msg = "";
		if resp.code == 10501 then
			msg = "昵称长度不符合要求";
		elseif resp.code == 10502 then
			msg = "昵称含有非法字符";
		elseif resp.code == 10503 then
			msg = "该昵称已存在";
		elseif resp.code == 10504 then
			msg = "不能重复创建角色";
		elseif resp.code == 10505 then
			msg = "创建失败（内部错误）";
		end
		QuickTips.ShowYellowQuickTips(msg);
	end
end	

-- 购买玩家皮肤返回
function spevent:user_buyroleskin(_, resp)
	log("user buy skin ok....."..resp.code);
	ShopSystem.Instance:OnBuyItem(resp.code);
end

-- 保存玩家皮肤返回
function spevent:user_saveroleskins(_, resp)
	log("user save skin ok....."..resp.code);
	MainCtrl.OnSaveAvatar(resp.code)
end

-- 账号登出返回 
function spevent:user_logout(_, resp)
	log("user save skin ok....."..resp.code);
	--[[if resp.code == 0 then
		-- 执行SDK 账号登出
		networkMgr:GameLoginOut();
	else
		-- 账号登出失败
		QuickTips.ShowYellowQuickTips("登出失败!");
		logWarn("user_logout faild....");
		AppConst.iSwitchUser = false;
	end--]]
end

-- 排行榜列表返回 --
function spevent:rank_getlist(_,resp)
	log("rank getlist ....");
	local _list = resp.list;
	if _list ~= nil and next(_list)  then
		RankCtrl.OnInitData(_list);
		Network.AwakePanel(CtrlNames.Rank);
	else
		QuickTips.ShowYellowQuickTips("目前还没有排行榜信息!");
	end
end

-- 排行榜角色形象返回 --
function spevent:rank_getuserskins(_,resp)
	log("rank getuserskins ....");
	local _skins = resp.skins;
	local code = resp.code;
	if code == 0 and _skins ~= nil and next(_skins) then
		RankCtrl.OnInitRoleFigure(_skins);
	else
		QuickTips.ShowYellowQuickTips("目前还没有此角色的形象信息!");
	end
end

-- 宝箱列表消息返回 --
function  spevent:box_getlist(_,resp)
	log("box get list ....");
	local boxes = resp.boxes;
	MainCtrl.SetBoxList(boxes);
end

-- 宝箱解锁消息返回 --
function spevent:box_unlock(_,resp)
	log("box  get box unlock....");
	local code = resp.code;
	local box = resp.box;
	
	MainCtrl.SetBoxUnlock(code,box);
end

-- 打开宝箱消息返回 -- 
function spevent:box_open(_,resp)
	log("box  open....");
	local  gold = resp.gold;
	local  diamone = resp.diamond;
	local  code = resp.code;
	MainCtrl.GetBoxOpen(gold,diamond,code);
end

-- 七日登录数据返回 --
function spevent:activity_newbierewardstatus(_,resp)
	log("sevenday data ....");
	MainCtrl.OnInitSevenDayData(resp.day,resp.canreward);
end

-- 七日登录领取奖励返回 --
function spevent:activity_newbiegetreward(_,resp)
	log("sevenday reward ....");
	if resp.code == 0 then
		SevenDayLoginCtrl.UpdateSevenDayUI(resp)
	else
		if resp.code == 50202 then
			QuickTips.ShowYellowQuickTips("领取奖励失败,未到时间!");
		elseif resp.code == 50201 then
			QuickTips.ShowYellowQuickTips("领取奖励失败,已领取此奖励");
		end
	end
end

return spevent