
local sproto = require "3rd/sproto/sproto"
local crypt = require "crypt"
local message = {}
local var = {
    session_id = 0 ,
    session = {},
    object = {},
}

function message.register()	
	local s2c = require "3rd/sproto/protos/s2c"
	var.host = sproto.parse(s2c):host "package"
	local c2s = require "3rd/sproto/protos/c2s"
	var.request = var.host:attach(sproto.parse(c2s))
	log("message.register......")
end

function message.bind(obj, handler)
    var.object[obj] = handler
end

local secret = nil
function message.setsecret(secretstr)
    secret = secretstr
end

local bigpackid = 0
local function bigid() --ְid
    bigpackid = bigpackid + 1
    if bigpackid > 255 then
        bigpackid = 1
    end
    return bigpackid
end

-- 
local packbuf = {}

function message.request(name, args)
    var.session_id = var.session_id + 1
    var.session[var.session_id] = { name = name, req = args }
    local msg = var.request(name , args, var.session_id)
    if secret then
        msg = crypt.desencode(secret, msg)
    end
    if string.len(msg) > 2^16 - 4 then
        local id = bigid()
        local p = 1
        local count = 1
        repeat
            assert(count <= 32)
            if p + 2^15 > string.len(msg) then
                count = 0
            end
			
			local buffer = ByteBuffer.New();
			buffer:WriteByte(id);
			buffer:WriteByte(count);
			buffer:WriteUnShortBuffer(msg:sub(p, p+2^15-1));
			networkMgr:SendMessage(buffer);
            count = count + 1
            p = p + 2^15
        until p > string.len(msg)
    else
		--log("message.request name:"..name);
		local buffer = ByteBuffer.New();
		buffer:WriteByte(0);
		buffer:WriteByte(0);
		buffer:WriteBuffer(msg);
		networkMgr:SendMessage(buffer);
    end

    return var.session_id
end

function message.receive(buffer)
    local bigid = buffer:ReadByte();
	local seq = buffer:ReadByte();
	local flag1 = buffer:ReadByte();
	local len1 = buffer:ReadByte();
	len1 = flag1 * 256 + len1;
	buffer:SetLenBuffer(len1);
	--log("content len:"..len1);
	local block = buffer:ReadShortBuffer();
	local msg
    if bigid == 0 then
        msg = block
    else
        --print("Received big package:", bigid, seq)
        if not packbuf[bigid] then
            assert(seq == 1)
            packbuf[bigid] = {seq = seq, buf = block}
        else
            if seq == 0 then
                msg = packbuf[bigid].buf .. block
                packbuf[bigid] = nil
            else
                assert(seq == packbuf[bigid].seq + 1)
                packbuf[bigid].seq = seq
                packbuf[bigid].buf = packbuf[bigid].buf .. block
            end
        end
    end
    if not msg then
        return false
    end
    if secret then
        msg = crypt.desdecode(secret, msg)
        --log("content str:"..msg)
    end

    local t, session_id, resp, err = var.host:dispatch(msg) --val
    if t == "REQUEST" then
        for obj, handler in pairs(var.object) do
            local f = handler[session_id]	-- session_id is request type
            if f then
                local ok, err_msg = pcall(f, obj, resp)	-- resp is content of push
                if not ok then
                    print(string.format("push %s for [%s] error : %s", session_id, tostring(obj), err_msg))
                end
            end
        end
    else
        local session = var.session[session_id]
        var.session[session_id] = nil
        for obj, handler in pairs(var.object) do
            if err then
                local f = handler.__error
                if f then
                    local ok, err_msg = pcall(f, obj, session.name, err, session.req, session_id)
                    if not ok then
                        print(string.format("session %s[%d] error(%s) for [%s] error : %s", session.name, session_id, err, tostring(obj), err_msg))
                    end
                end
            else
                local f = handler[session.name]
                if f then
                    local ok, err_msg = pcall(f, obj, session.req, resp, session_id)
                    if not ok then
                        print(string.format("session %s[%d] for [%s] error : %s", session.name, session_id, tostring(obj), err_msg))
                    end
                end
            end
        end
    end

    return true
end


return message