require "Common/define"

InfoCtrl = {};

InfoData = {};

local this = InfoCtrl;

local panel;
local info;
local transform;
local gameObject;
local m_type;
local m_rollmsg = {};
local m_timer = nil;

function InfoCtrl.New()
	logWarn("InfoCtrl.New--->>");
	return this;
end

function InfoCtrl.Awake()
	logWarn("InfoCtrl.Awake--->>");
	panelMgr:CreatePanel('Info', this.OnCreate);
	
	if InfoPanel.btnSure then
		this.InitPanel();
	end
end

function InfoCtrl.SetSystemType(msgType)
	m_type = msgType;
end

function InfoCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;

	-- panel = transform:GetComponent('UIPanel');
	info = transform:GetComponent('LuaBehaviour');
	logWarn("Info lua--->>"..gameObject.name);

	this.InitPanel();	

	info:AddClick(InfoPanel.btnSure,this.Close);
	
end

function InfoCtrl.InitPanel()
	--[[if m_type == 1 then
		InfoCtrl.ShowInfoPanel();
	else
		InfoCtrl.ShowRollMsg();
	end--]]
	
	InfoCtrl.ShowInfoPanel();
end

function InfoCtrl.OnInitData(code,ishow)
	InfoData.code = code;
	InfoData.ishow = ishow;
end

function InfoCtrl.OnInitRollMsg(code,ishowTxt,msg)
	m_rollmsg.code = code;
	m_rollmsg.ishowTxt = ishowTxt;
	m_rollmsg.msg = msg;
end

function InfoCtrl.ShowInfoPanel()
	InfoPanel.alert:SetActive(true);
	InfoPanel.rollmsg:SetActive(false);
	InfoPanel.cellmsg:SetActive(false);
	if InfoData.code == 1 then
		InfoPanel.alertTxt:GetComponent('Text').text = "服务器连接断开,正在重连中...";
	elseif InfoData.code == 2 then
		InfoPanel.alertTxt:GetComponent('Text').text = "服务器连接成功...";
	elseif InfoData.code == 3 then
		InfoPanel.alertTxt:GetComponent('Text').text = "正在登陆中...";
	else 
		InfoPanel.alertTxt:GetComponent('Text').text = "服务器忙碌中...";
	end
	networkMgr:ShowLoading(InfoData.ishow);
end

function InfoCtrl.ShowRollMsg()
	InfoPanel.alert:SetActive(false);
	InfoPanel.rollmsg:SetActive(true);
	InfoPanel.cellmsg:SetActive(true);
	if m_rollmsg.ishowTxt then
		InfoPanel.msgTxt:GetComponent('Text').text = m_rollmsg.msg;
	else
		InfoPanel.msgTxt:GetComponent('Text').text = "错误码:"..m_rollmsg.code;
	end
	
	--[[if m_timer == nil then
		m_timer = Timer.New(this.HideRollMsg, 3, 1, true);
	end
	m_timer:Start();--]]
end

function InfoCtrl.HideRollMsg()
	if m_timer then
		m_timer:Stop();
		InfoPanel.rollmsg:SetActive(false);
		InfoPanel.cellmsg:SetActive(false);
		InfoCtrl.Close();
	end
end

function InfoCtrl.Close()
	panelMgr:ClosePanel(PanelNames.Info);
end