require "Common/define"

LoginCtrl = {}

local this = LoginCtrl;

local panel;
local login;
local transform;
local gameObject;

function LoginCtrl.New()
	logWarn("LoginCtrl.New--->>");
	return this;
end

function LoginCtrl.Awake()
	logWarn("LoginCtrl.Awake--->>");
	AvatarManager.Instance:DestroryAll();
	soundMgr:PlayMusicId("bgm1");
	panelMgr:CreatePanel('Login', this.OnCreate);
	
	
end

function LoginCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;

	-- panel = transform:GetComponent('UIPanel');
	login = transform:GetComponent('LuaBehaviour');
	logWarn("Login lua--->>"..gameObject.name);

	this.InitPanel();	
	
	if AppConst.isPlatformSDK then
		LoginPanel.content:SetActive(false);
		LoginPanel.contentSDK:SetActive(true);
		
		Network.ShowSystemMessage(3,true);
		networkMgr:ShowLoading(true);

		login:AddClick(LoginPanel.btnEnter,this.OnEnterClick);
		login:AddClick(LoginPanel.btnLogin,this.OnLoginClick);
	else
		LoginPanel.content:SetActive(true);
		LoginPanel.contentSDK:SetActive(false);
		
		login:AddClick(LoginPanel.btnGuest,this.OnGuestClick);
		
		if LoginPanel.openTxt then
			LoginPanel.openPreTxt:GetComponent('Text').text = "";
			LoginPanel.openTxt:GetComponent('Text').text = "";
			local label = LoginPanel.openTxt;
			local devid = AppConst.DEVID;
			LoginPanel.openPreTxt:GetComponent('Text').text = devid;
			LoginPanel.inputOpenID:GetComponent('InputField').text = devid;
		end
	end
end

function LoginCtrl.InitPanel()
	LoginPanel.text_version:GetComponent('Text').text=DataEntry.loginModel.version;
end

function LoginCtrl.OnEnterClick(go)
	logWarn("click enter button..........>>>>")
	AvatarManager.Instance:DestroryAll();
	if DataEntry.loginModel.platformUid ~= "" then
		LoginCtrl.LoginConnect();
	else
		QuickTips.ShowRedQuickTips("账号登录失败,请重试!");
	end
end

function LoginCtrl.OnGuestClick(go)
	logWarn("click guest button..........>>>>")
	
	if AppConst.isPlatformSDK == false then
		DataEntry.loginModel.platformUid = LoginPanel.inputOpenID:GetComponent('InputField').text;
		print("platformUid:",DataEntry.loginModel.platformUid);
	end
	
	if DataEntry.loginModel.platformUid ~= "" then
		LoginCtrl.LoginConnect();
	else
		QuickTips.ShowRedQuickTips("账号登录失败,请重试!");
	end
end

function LoginCtrl.OnLoginClick(go)
	logWarn("click login button..........>>>>");
	networkMgr:ReLoginPluginTool();
end

function LoginCtrl.SetLoginBtnActive(isActive)
	LoginPanel.btnEnter:SetActive(isActive);
	LoginPanel.btnLogin:SetActive(not isActive);
	
	InfoCtrl.Close();
	networkMgr:ShowLoading(false);
end

function LoginCtrl.LoginConnect()
	AvatarManager.Instance:DestroryAll();
	AppConst.SocketPort = LOGINPORT; --2012;
    AppConst.SocketAddress = LOGINIP; --"192.168.1.123"--"123.59.14.125" --"127.0.0.1"
    networkMgr:SendConnect();
end

function LoginCtrl.Close()
	panelMgr:ClosePanel(PanelNames.Login);
end