require "Common/define"

MatchCtrl = {};

local this = MatchCtrl;

local panel;
local match;
local transform;
local gameObject;

MatchUserData = {};
MyTeamUsers = {};
EnemyTeamUsers = {};
SelfTeam = 0;

local TotalCount = 10;
local TotalCD = 15;
local leftCount = 0;
local SelectRoleCD = 4;
local ReadyCount = 0;
local matchDesc = "匹配";
local matchingDesc = "已经过"
local readyDesc = "已就绪";
local cdDesc = "倒计时";
local secondTxt = "秒";
local startDesc = "后进入游戏"
local timer = nil;
local timer1 = nil;

local IngTimer = nil;
local IngCount = 1;
--local selfTeam = 0;
local roleList = {};

function MatchCtrl.New()
	logWarn("MatchCtrl.New--->>");
	return this;
end

function MatchCtrl.Awake()
	logWarn("MatchCtrl.Awake--->>");
	panelMgr:CreatePanel('Match', this.OnCreate);
	
	if MatchPanel.MatchingPanel.activeSelf == false then
		MatchPanel.MatchingPanel:SetActive(true);
		MatchPanel.MatchedPanel:SetActive(false);
		PlayersData = {};
		MatchUserData = {};
		MyTeamUsers = {};
		EnemyTeamUsers = {};
		TotalCD = 15;
		SelfTeam = 0;
		leftCount = 0;
		IngCount = 1;
		ReadyCount = 0;
		MatchCtrl.ClearRoleList();
		MatchPanel.ready:SetActive(true);
		MatchCtrl.InitPanel();
	end

end

function MatchCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;

	-- panel = transform:GetComponent('UIPanel');
	match = transform:GetComponent('LuaBehaviour');
	logWarn("Match lua--->>"..gameObject.name);

	this.InitPanel();	

	match:AddClick(MatchPanel.btnEnter,this.OnEnterClick);	
	match:AddClick(MatchPanel.btnCancel,this.OnCancelClick);	
	
end

function MatchCtrl.InitPanel()
	MatchPanel.passTime:GetComponent('Text').text = matchingDesc.."1"..secondTxt;
	if IngTimer == nil then
		IngTimer = Timer.New(this.SetMatchingTime, 1, -1, true);
	end
	IngTimer:Start();
	
end

function MatchCtrl.SetMatchingTime()
	IngCount = IngCount + 1;
	local _desc = matchingDesc..IngCount..secondTxt;
	MatchPanel.passTime:GetComponent('Text').text = _desc;
	
	if IngCount == 3 then
		--MatchCtrl.ShowMatchedPanel();
		--[[local _isFinish = MatchCtrl.GetFinishCondition();
		if _isFinish then
			MatchCtrl.ShowMatchedPanel();
		end--]]
	end
	
end

function MatchCtrl.ShowMatchedPanel()
	if MatchPanel.MatchingPanel == nil then
		log(">>>>>>>>>>> MatchingPanel is nil");
		return;
	end
	if MatchPanel.MatchedPanel == nil then
		log(">>>>>>>>>>> MatchedPanel is nil");
		return;
	end
	MatchPanel.MatchingPanel:SetActive(false);
	MatchPanel.MatchedPanel:SetActive(true);
	if next(MatchUserData) then
		local len = #MatchUserData;
		MatchPanel.ready:GetComponent('Text').text = len.."/"..TotalCount..""..readyDesc;
	end
		
	logWarn("create Timer ....");
	
	if timer == nil then
		timer = Timer.New(this.SetCDTime, 1, -1, true);
	else
		timer:Stop();
	end
	timer:Start();
	
end

function MatchCtrl.initData()
	local _total = #MatchUserData;
	for i=1,_total do
		local teamType = MatchUserData[i].team;
		if SelfTeam == teamType then
			--MatchCtrl.IsExistsUser(MatchUserData[i],MyTeamUsers)
			local isExist1 = MatchCtrl.IsExistsUser(MatchUserData[i],MyTeamUsers);
			if not isExist1 then
				local _len1 = #MyTeamUsers;
				MatchCtrl.SetHeadReady(_len1,SelfTeam,true,MatchUserData[i].userindex,MatchUserData[i].sex);
			end
		else
			--MatchCtrl.IsExistsUser(MatchUserData[i],EnemyTeamUsers)
			local isExist2 = MatchCtrl.IsExistsUser(MatchUserData[i],EnemyTeamUsers);
			if not isExist2 then
				local _len2 = #EnemyTeamUsers;
				MatchCtrl.SetHeadReady(_len2,teamType,true,MatchUserData[i].userindex,MatchUserData[i].sex);
			end
		end
	end
end

function MatchCtrl.SetHeadReady(index,teamType,isVisiable,userindex,sex)
	local _selfList = MatchPanel.selfList;
	local _enemyList = MatchPanel.enemyList;
	
	if _selfList and _enemyList then
		local _tf = _enemyList.transform;
		local typeStr = "Player";
		if teamType == SelfTeam then
			_tf = _selfList.transform;
		end
		
		local user = _tf:FindChild(typeStr.."_"..index).gameObject;
		local ready = user.transform:FindChild("Ready").gameObject;
		local loading = user.transform:FindChild("Loading").gameObject;
		local icon = user.transform:FindChild("Img_Portrait").gameObject;

		icon:SetActive(true);
		ready:SetActive(not isVisiable);
		loading:SetActive(isVisiable);
		
		-- 10101 第二个的1代表角色类型,第三个的1代表角色皮肤
		local img = icon:GetComponent('Image');
		local imgStr = "Head_10"..sex.."01";
		local sp = resMgr:LoadSprite(imgStr,imgStr);
		img.sprite = sp;
		
		table.insert(roleList,user);
	end
end

function MatchCtrl.ClearRoleList()
	if next(roleList) then
		for _,user in pairs(roleList) do
			local ready = user.transform:FindChild("Ready").gameObject;
			local icon = user.transform:FindChild("Img_Portrait").gameObject;

			icon:SetActive(false);
			ready:SetActive(false);
		end
	end
end

function MatchCtrl.SetCDTime()
	TotalCD = TotalCD - 1;
	leftCount = TotalCD;
	local _desc = cdDesc..leftCount..secondTxt;
	if leftCount <= 0 then
		leftCount = 0;
		if timer then
			timer:Stop();
			--timer = nil;
		end
		_desc = "";
	end
	MatchPanel.cd:GetComponent('Text').text = _desc;
end

-- 获取已经匹配成功的玩家 -- 
function MatchCtrl.SetUsersData(userid,nickname,userindex,icon,ready,team,sex)
	local _data = {};
	_data.userid = userid;
	_data.nickname = nickname;
	_data.userindex = userindex;
	_data.icon = icon;
	_data.ready = ready;
	_data.team = team;
	_data.sex = sex;
	
	MatchCtrl.IsExistsUser(_data,MatchUserData);
	
	if userid == AppConst.USERID then
		log("本人团队标记....."..team);
		SelfTeam = team;
		AppConst.USERTEAM = team;
		--MatchCtrl.IsExistsUser(_data,MyTeamUsers)
	else
		--MatchCtrl.IsExistsUser(_data,EnemyTeamUsers)
	end
	--this.initData();
end

function MatchCtrl.IsExistsUser(_data,userlist)
	local isExist = false;
	for index,v in pairs(userlist) do
		if _data.userid == v.userid then
			isExist = true;
		end
	end
	if isExist == false then
		table.insert(userlist,_data);
	end
	
	return isExist
end

-- 获取后入匹配成功的玩家 -- 
function MatchCtrl.SetUserData(userid,nickname,userindex,icon,ready,team,sex)
	local _data = {};
	_data.userid = userid;
	_data.nickname = nickname;
	_data.userindex = userindex;
	_data.icon = icon;
	_data.ready = ready;
	_data.team = team;
	_data.sex = sex;
	
	if SelfTeam == team then
		local isExist1 = MatchCtrl.IsExistsUser(_data,MyTeamUsers);
		if not isExist1 then
			local _len1 = #MyTeamUsers;
			MatchCtrl.SetHeadReady(_len1,SelfTeam,true,userindex,sex);
		end
	else
		if userid ~= AppConst.USERID then
			local isExist2 = MatchCtrl.IsExistsUser(_data,EnemyTeamUsers);
			if not isExist2 then
				local _len2 = #EnemyTeamUsers;
				MatchCtrl.SetHeadReady(_len2,team,true,userindex,sex);
			end
		end
	end
	
	MatchCtrl.IsExistsUser(_data,MatchUserData);
	--[[local _isFinish = MatchCtrl.GetFinishCondition();
	if _isFinish then
		MatchCtrl.ShowMatchedPanel();
	end--]]
end

function MatchCtrl.GetFinishCondition()
	local _len = #MatchUserData;
	if AppConst.ROOMTYPE == RoomTpye.Five and _len == RoomTotal.Five then
		return true;
	elseif AppConst.ROOMTYPE == RoomTpye.Sceond and _len == RoomTotal.Sceond then
		return true;
	elseif AppConst.ROOMTYPE == RoomTpye.Three and _len == RoomTotal.Three then 
		return true;
	elseif AppConst.ROOMTYPE == RoomTpye.Frist and _len == RoomTotal.Frist then 
		return true;
	elseif AppConst.ROOMTYPE == RoomTpye.Four and _len == RoomTotal.Four then 
		return true;
	elseif AppConst.ROOMTYPE == RoomTpye.Test and _len == RoomTotal.Test then
		return true;
	else 
		return false;
	end
end

function MatchCtrl.OnEnterClick(go)
	logWarn("click enter button..........>>>>");
	
	local _total = MatchCtrl.JudgeTeamUserCount();
	if _total ~= 10 then
		QuickTips.ShowYellowQuickTips("匹配人数不满足条件!");
		return;
	end
	
	if AppConst.USERINDEX == 0 then
		QuickTips.ShowYellowQuickTips("匹配标记错误!");
		return;
	end
	
	-- ready
	networkMgr:ShowLoading(true);
	networkMgr:ReadyEnterGame();
end

function MatchCtrl.OnCancelClick(go)
	logWarn("click cancel button..........>>>>");
	networkMgr:ShowLoading(true);
	networkMgr:MatchCancel(AppConst.ROOMTYPE);
end

function MatchCtrl.OnUpdateMatchStatus(userindex)
	--MatchPanel.btnEnter 变灰
	--log("OnUpdateMatchStatus userindex:"..userindex)
	
	local _index,_data = MainCtrl.GetMatchPlayerByIndex(userindex);
	if _data == nil then
		logError("error userindex:"..userindex)
	else
		MatchCtrl.SetHeadReady(_index,_data.team,false,_data.userindex,_data.sex);
		ReadyCount = ReadyCount + 1;
		MatchPanel.ready:GetComponent('Text').text = ReadyCount.."/"..TotalCount..""..readyDesc;
	end
end

function MatchCtrl.JudgeTeamUserCount()
	local _mylen = #MyTeamUsers;
	local _enlen = #EnemyTeamUsers;
	
	local _total = _mylen + _enlen;
	
	return _total;
	
end

function MainCtrl.GetMatchPlayerByIndex(userindex)
	
	local _mylen = #MyTeamUsers;
	local _enlen = #EnemyTeamUsers;
	
	for i=1,_mylen do
		if userindex == MyTeamUsers[i].userindex then
			return i,MyTeamUsers[i];
		end
	end
	
	for j=1,_enlen do
		if userindex == EnemyTeamUsers[j].userindex then
			return j,EnemyTeamUsers[j];
		end
	end
	
	return 0,nil;
end

function MatchCtrl.OnStartSelectRoleCD()
	
	if timer then
		timer:Stop();
		--timer = nil;
	end
	
	MatchPanel.ready:SetActive(false);
	MatchPanel.cd:GetComponent('Text').text = "";
	--timer1 = Timer.New(this.StartSelectRole, 1, -1, true);
	--timer1:Start();
	MainCtrl.Close();
	this.Close();
	Network.AwakePanel(CtrlNames.SelectRole);
	networkMgr:ShowLoading(false);
end

function MatchCtrl.StartSelectRole()
	SelectRoleCD = SelectRoleCD - 1;
	local _desc = matchDesc..SelectRoleCD..secondTxt..startDesc;
	if SelectRoleCD <= 0 then
		SelectRoleCD = 0;
--[[		if timer1 then
			timer1:Stop();
		end--]]
		this.Close();
		Network.AwakePanel(CtrlNames.SelectRole);
		_desc = "";
	end
	MatchPanel.cd:GetComponent('Text').text = _desc;
end

function MatchCtrl.Close()
	panelMgr:ClosePanel(PanelNames.Match);
	if timer then
		timer:Stop();
		--timer = nil;
	end
	if IngTimer then
		IngCount = 1;
		IngTimer:Stop();
		--IngTimer = nil;
	end
	MatchPanel.MatchingPanel:SetActive(false);
	MatchPanel.MatchedPanel:SetActive(false);
end