require "Common/define"

RankCtrl = {}

local this = RankCtrl;

local panel;
local rank;
local transform;
local gameObject;

local ranklist = {};
local rankCount = 8;
local openState = 1;
local rankdata = {};
local myrankdata = nil;

local currUserID = nil;
local currSex = nil;
local currAvatar = nil;
local lastIndex = 0;

function RankCtrl.New()
	logWarn("RankCtrl.New--->>");
	return this;
end

function RankCtrl.Awake()
	logWarn("RankCtrl.Awake--->>");
	panelMgr:CreatePanel('Rank', this.OnCreate);
	
	if RankPanel.btnReturn then
		RankCtrl.OnCreateRankList();
	end
	
end

function RankCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;

	-- panel = transform:GetComponent('UIPanel');
	rank = transform:GetComponent('LuaBehaviour');
	logWarn("Rank lua--->>"..gameObject.name);

	this.InitPanel();	

	
	rank:AddClick(RankPanel.btnReturn,this.Close);
	rank:AddOnValueChangeClick(RankPanel.btnResouce,this.OnInitRankResData);
	rank:AddOnValueChangeClick(RankPanel.btnKill,this.OnInitRanKillkData);
	rank:AddOnValueChangeClick(RankPanel.btnDay,this.OnInitRankDayData);
	rank:AddOnValueChangeClick(RankPanel.btnSeason,this.OnInitRankSeasonData);
	
end

function RankCtrl.InitPanel()

end

function RankCtrl.OnInitData(rdata)
	rankdata = rdata;
	
	for index,v in pairs(rankdata) do
		if v.userid == AppConst.USERID then
			myrankdata = v;
		end
	end
	
	local _len = #rankdata;
	
end

function RankCtrl.OnInitRoleFigure(skins)
	local _skins = "";
	for index,v in ipairs(skins) do
		if v.skin_id > 0 then
			_skins = v.skin_id.."&".._skins;
		end
	end
	
	if currAvatar ~= nil then
		local _id = lastIndex;
		AvatarManager.Instance:DestroyAvata(_id);
	end
	
	currAvatar = AvatarManager.Instance:CreateRankAvatarInfo(currUserID,currSex,_skins);
	RankCtrl.CreateAvatarUI();
	
	lastIndex = currUserID;
end

function RankCtrl.CreateAvatarUI(avatar)
	local parent = RankPanel.playerRoot;
	currAvatar.transform:SetParent(parent);
	currAvatar.gameObject.name = tostring(currUserID);
	currAvatar.transform.localScale = Vector3.one;
	currAvatar.transform.localPosition = Vector3.zero;
	currAvatar.transform.rotation = Vector3.zero;
end

function RankCtrl.ClearRankList()
	if next(ranklist) then
		for _,v in pairs(ranklist) do
			destroy(v);
		end
	end
end

function RankCtrl.OnCreateRankList()
	RankCtrl.ClearRankList();
	RankCtrl.OnInitMyRankData();
	resMgr:LoadPrefab('cell_rank', { 'Cell_Rank' }, this.CreateCell);
end

function RankCtrl.OnChosePlayer(name,sex,userid,index)
	local _tf = RankPanel.chose.transform;
	
	local _name = _tf:FindChild("Txt_Nickname").gameObject:GetComponent('Text');
	_name.text = name;
	
	local img = _tf:FindChild("Img_Portrait").gameObject:GetComponent('Image');
	local imgStr = "Head_10"..sex.."01";
	local sp = resMgr:LoadSprite(imgStr,imgStr);
	img.sprite = sp;
	
	currSex = sex;
	currUserID = index;
	
	Network.SendUserFigure(userid);

end

function RankCtrl.OnInitMyRankData()

	if myrankdata ~= nil then
		RankPanel.mine:SetActive(true);
		local _tf = RankPanel.mine.transform;
	
		local _name = _tf:FindChild("Txt_Nickname").gameObject:GetComponent('Text');
		_name.text = AppConst.USERNAME;
		
		local _rank1 = _tf:FindChild("Rank_1").gameObject;
		local _rank2 = _tf:FindChild("Rank_2").gameObject;
		local _rank3 = _tf:FindChild("Rank_3").gameObject;
		
		local _rank = _tf:FindChild("Rank").gameObject:GetComponent('Text');
		_rank.text = myrankdata.rank;
			
		-- 头像暂时用性别来区分
		local img = _tf:FindChild("Img_Portrait").gameObject:GetComponent('Image');
		local imgStr = "Head_10"..myrankdata.sex.."01";
		local sp = resMgr:LoadSprite(imgStr,imgStr);
		img.sprite = sp;
		
		local _count = _tf:FindChild("Txt_Count").gameObject:GetComponent('Text');
		_count.text = myrankdata.win;
		
		local _total = _tf:FindChild("Txt_Count_Total").gameObject:GetComponent('Text');
		_total.text = myrankdata.totalwin;
	else
		RankPanel.mine:SetActive(false);
	end
	
	
end

--[[rank 0 : integer
			userid 1 : string
			nickname 2 : string
			icon 3 : string
			win 4 : integer
			totalwin 5 : integer--]]

function RankCtrl.CreateCell(objs)
	local count = #rankdata;
	local parent = RankPanel.gridParent;
	for i = 1, count do
		local go = newObject(objs[0]);
		go.name = "RankCell"..tostring(i);
		go.transform:SetParent(parent);
		go.transform.localScale = Vector3.one;
		go.transform.localPosition = Vector3.zero;
		
		local _data = rankdata[i];
		
		local _btn = go.transform:FindChild("Btn_Chose").gameObject;
		
		local _strName = _data.nickname;
		local _sex = _data.sex;
		
		_btn.name = _strName.."&"..tostring(_sex).."&".._data.userid.."&"..i;
		
		local img = go.transform:FindChild("Img_Portrait").gameObject:GetComponent('Image');
		local imgStr = "Head_10".._sex.."01";
		local sp = resMgr:LoadSprite(imgStr,imgStr);
		img.sprite = sp;
		
        rank:AddClick(_btn, RankCtrl.OnSelectClick);
		
		local _rank1 = go.transform:FindChild("Rank_1").gameObject;
		local _rank2 = go.transform:FindChild("Rank_2").gameObject;
		local _rank3 = go.transform:FindChild("Rank_3").gameObject;
		local _rankTxt = go.transform:FindChild("Rank").gameObject:GetComponent('Text');
		
		
		_rank1:SetActive(false);
		if _data.rank == 1 then
			_rank1:SetActive(true);
		elseif _data.rank == 2 then 
			_rank2:SetActive(true);
		elseif _data.rank == 3 then
			_rank3:SetActive(true);
		else
			_rankTxt.text = _data.rank;
		end
		
		local _name = go.transform:FindChild("Txt_Nickname").gameObject:GetComponent('Text');
		_name.text = _strName;
		
		local _count = go.transform:FindChild("Txt_Count").gameObject:GetComponent('Text');
		_count.text = _data.win;
		
		local _total = go.transform:FindChild("Txt_Count_Total").gameObject:GetComponent('Text');
		_total.text = _data.totalwin;
		
		if i == 1 then
			RankCtrl.OnChosePlayer(_name.text,_sex,_data.userid,i);
		end
		
		table.insert(ranklist,go);
	end
end

function RankCtrl.OnSelectClick(go)
	logWarn("btn name:"..go.name);
	
	local splitlist = {}
	string.gsub(go.name, '[^&]+', function(w) table.insert(splitlist, w) end )
	log("name:"..splitlist[1])
	log("sex:"..splitlist[2])
	log("index:"..splitlist[4])
	local _nameStr = splitlist[1];
	RankCtrl.OnChosePlayer(_nameStr,tonumber(splitlist[2]),splitlist[3],splitlist[4]);
	
end

function RankCtrl.OnInitRankResData(go)
	logWarn("OnInitRankResData..........>>>>");
	
	local _toggle1 = go:GetComponent('Toggle');
	if _toggle1.isOn then
		--logWarn("")
	end
	logWarn("_toggle1.isOn:"..tostring(_toggle1.isOn));
end

function RankCtrl.OnInitRankKillData(go)
	logWarn("OnInitRankKillData..........>>>>");
	
	local _toggle2 = go:GetComponent('Toggle');
	logWarn("_toggle2.isOn:"..tostring(_toggle2.isOn));
end

function RankCtrl.OnInitRankDayData(go)
	logWarn("OnInitRankData2..........>>>>");
	
	local _toggle1 = go:GetComponent('Toggle');
	if _toggle1.isOn then
		--logWarn("")
		if openState ~= 1 then
			--rankCount = 8;
			Network.SendRankList("rob","day");
			--RankCtrl.OnCreateRankList();
		end
		openState = 1;
	end
	
	logWarn("_toggle1.isOn:"..tostring(_toggle1.isOn));
end

function RankCtrl.OnInitRankSeasonData(go)
	logWarn("OnInitRankSeasonData..........>>>>");
	
	local _toggle2 = go:GetComponent('Toggle');
	logWarn("_toggle2.isOn:"..tostring(_toggle2.isOn));
	if _toggle2.isOn then
		--logWarn("")
		if openState ~= 2 then
			--rankCount = 5;
			Network.SendRankList("rob","season");
			--RankCtrl.OnCreateRankList();
		end
		openState = 2 ;
	end
	
end

function RankCtrl.Close()
	panelMgr:ClosePanel(PanelNames.Rank);
end