require "Common/define"

ResultCtrl = {}

local this = ResultCtrl;

local panel;
local result;
local transform;
local gameObject;

local myself = nil;
local enemy = nil;

local bestList = {};
local resultData = {};

local _expStr = "经验";
local _goldStr = "金币";
--# 最高项 killcount击杀数,bestkillcombo最高连杀,totalheal治疗量,avliverate生存,bestdamagecomboe最高累计伤害
local _killcountStr = "最高击杀数";
local _bestkillcomboStr = "最高连杀数";
local _totalhealStr = "最高治疗量";
local _avliverateStr = "最高生存数";
local _bestdamagecomboeStr = "最高累计伤害";
local _assestStr = "最高助攻数"

function ResultCtrl.New()
	logWarn("ResultCtrl.New--->>");
	return this;
end

function ResultCtrl.Awake()
	logWarn("ResultCtrl.Awake--->>");
	panelMgr:CreatePanel('Result', this.OnCreate);

	if ResultPanel.FinePlay.activeSelf == false then
		ResultPanel.FinePlay:SetActive(true);
		ResultPanel.Reward:SetActive(false);
		
		ResultCtrl.InitPanel();
	end
end

function ResultCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;

	result = transform:GetComponent('LuaBehaviour');
	logWarn("Result lua--->>"..gameObject.name);

	myself = ResultPanel.Ally;
	enemy = ResultPanel.Enemy;

	this.InitPanel();	

	result:AddClick(ResultPanel.btnNext,this.OnNextClick);
	
	result:AddClick(ResultPanel.btnBack,this.OnBackClick);
	result:AddClick(ResultPanel.btnMatch,this.OnMatchClick);
	
end

function ResultCtrl.InitPanel()
	if next(MyTeamUsers) then
		local _len = #MyTeamUsers;
		for i=1,_len do
			ResultCtrl.SetPlayerReady(i,MyTeamUsers[i].nickname,myself,MyTeamUsers[i].userindex);
		end
	end
	if next(EnemyTeamUsers) then
		local _len = #EnemyTeamUsers;
		for i=1,_len do
			ResultCtrl.SetPlayerReady(i,EnemyTeamUsers[i].nickname,enemy,EnemyTeamUsers[i].userindex);
		end
	end
	
	if next(bestList) then
		local _count = #bestList;
		for j=1,_count do
			ResultCtrl.SetBestUI(bestList[j],j);
		end
	end
	
	ResultPanel.Win:SetActive(false);
	ResultPanel.Lose:SetActive(false);
	ResultPanel.Tie:SetActive(false);
	
	if resultData.win == 0 then
		ResultPanel.Lose:SetActive(true);
		ResultPanel.Chest:SetActive(false);
    soundMgr:PlayUISound("UI005");
	elseif resultData.win == 1 then 
		ResultPanel.Win:SetActive(true);
		ResultPanel.Chest:SetActive(true);
    soundMgr:PlayUISound("UI004");
	else
		ResultPanel.Tie:SetActive(true);
	end
end

function ResultCtrl.SetBestUI(bdata,index)
	local _tf = ResultPanel.FinePlay.transform;
	
	local _data = SelectRoleCtrl.GetPlayerDataByID(bdata.userindex);
	local _role = SelectRoleCtrl.GetUserName(bdata.userindex);
	
	local user = _tf:FindChild("Cell_FinePlay"..index).gameObject;
	local icon = user.transform:FindChild("Img_Portrait").gameObject;
	local name = user.transform:FindChild("Text_Nickname").gameObject;
	local btype = user.transform:FindChild("Text_Type").gameObject;
	local result = user.transform:FindChild("Text_Result").gameObject;
	
	local _win1 = user.transform:FindChild("Window").gameObject;
	local _win2 = user.transform:FindChild("Window1").gameObject;
	
	if _role.team == SelfTeam then
		_win1:SetActive(true);
		_win2:SetActive(false);
		
		name:GetComponent('Text').color = UnityEngine.Color(0,171,255);
		btype:GetComponent('Text').color = UnityEngine.Color(0,171,255);
		
	else
		_win1:SetActive(false);
		_win2:SetActive(true);
		
		name:GetComponent('Text').color = UnityEngine.Color.red;
		btype:GetComponent('Text').color = UnityEngine.Color.red;
	end
	
	
	-- 10101 第二个的1代表角色类型,第三个的1代表角色皮肤
	local img = icon:GetComponent('Image');
	local imgStr = "Head_10".._role.sex.."01";
	local sp = resMgr:LoadSprite(imgStr,imgStr);
	img.sprite = sp;
	
	local pname = _role.nickname;
	name:GetComponent('Text').text = pname;
	
	btype:GetComponent('Text').text = ResultCtrl.GetBestStr(bdata.key);
	result:GetComponent('Text').text = bdata.value;
	
	
	
end

function ResultCtrl.GetBestStr(str)
	if str == "1" then
		return _killcountStr;
	elseif str == "2" then
		return _bestkillcomboStr;
	elseif str == "3" then
		return _totalhealStr;
	elseif str == "4" then
		return _avliverateStr;
	elseif str == "5" then
		return _bestdamagecomboeStr;
	elseif str == "6" then
		return _assestStr;
	end
end

function ResultCtrl.SetPlayerReady(index,pname,userlist,userindex)
	local _tf = userlist.transform;
	
	local _data = SelectRoleCtrl.GetPlayerDataByID(userindex);
	local _role = SelectRoleCtrl.GetUserName(userindex);
	
	local user = _tf:FindChild("Player_"..index).gameObject;
	local icon = user.transform:FindChild("Img_Portrait").gameObject;
	local name = user.transform:FindChild("Text_Nickname").gameObject;

	icon:SetActive(true);
	name:SetActive(true);
	
	-- 10101 第二个的1代表角色类型,第三个的1代表角色皮肤
	local img = icon:GetComponent('Image');
	local imgStr = "Head_10".._role.sex.."01";
	local sp = resMgr:LoadSprite(imgStr,imgStr);
	img.sprite = sp;

	name:GetComponent('Text').text = pname;
end

function ResultCtrl.SetResultData(addgold,addexp,newlv,newexp,maxexp,win,boxid)
	resultData.addgold = addgold;
	resultData.addexp = addexp;
	resultData.newlv = newlv;
	resultData.newexp = newexp;
	resultData.maxexp = maxexp;
	resultData.win = win;
	resultData.boxid = boxid;
	
	MainCtrl.UpdataPlayerInfoUI();
end

function ResultCtrl.SetBestInfo(userindex,key,value)
	local _data = {};
	_data.userindex = userindex;
	_data.key = key;
	_data.value = value;
	
	table.insert(bestList,_data);
end

function ResultCtrl.OnNextClick(go)
	logWarn("click next button..........>>>>");
	
	ResultPanel.FinePlay:SetActive(false);
	
	ResultPanel.Reward:SetActive(true);
	
	ResultCtrl.SetResultUI();
end

function ResultCtrl.SetResultUI()
	local _tf = ResultPanel.Reward.transform;
	local _exp = _tf:FindChild("Exp/Text").gameObject;
	--经验+100
	_exp:GetComponent('Text').text = _expStr.."+"..resultData.addexp;

	--金币+666
	local _gold = _tf:FindChild("Money/Text").gameObject;
	_gold:GetComponent('Text').text = _goldStr.."+"..resultData.addgold;
	
	local _lv = _tf:FindChild("Text_Lv").gameObject;
	local _addlv = _tf:FindChild("Text_LvGrow").gameObject;
	
	_lv:GetComponent('Text').text = "Lv"..resultData.newlv;
	local _difflv = resultData.newlv - PlayerInfo.level;
	if _difflv > 0 then
		_addlv:GetComponent('Text').text = "+".._difflv;--增加等级数
		PlayerInfo.level = resultData.newlv;
	else
		_addlv:GetComponent('Text').text = "";
	end
	
	local slider = _tf.transform:FindChild("Prg").gameObject;
	_slider = slider:GetComponent('Slider');
	_slider.value = resultData.newexp/resultData.maxexp;
	PlayerInfo.exp = resultData.newexp;
	
	DataEntry.roleModel:InitUserInfo(PlayerInfo.sex,PlayerInfo.level,PlayerInfo.exp,PlayerInfo.gold,2);

	local  isCanAcceptBox = MainCtrl.GetCanAddBox();
	if  isCanAcceptBox  then
		ResultPanel.BoxFull:SetActive(false);
	else
		ResultPanel.BoxFull:SetActive(true);
	end

	if resultData.win == 1  then
		if resultData.boxid ~= 0 then
 			local img = ResultPanel.BoxImgIcon:GetComponent('Image');
	 		local imgName = tostring("Chest_"..resultData.boxid);
	 		local  sp = resMgr:LoadSprite(imgName,imgName);
			img.sprite = sp;

		end 
	end

	
end 

function ResultCtrl.OnBackClick(go)
	logWarn("click back button..........>>>>");
	
	ResultCtrl.Close();
	Network.AwakePanel(CtrlNames.Main);
	Network.SendBoxGetList();
end

function ResultCtrl.OnMatchClick(go)
	logWarn("click macth button..........>>>>");
	
	ResultCtrl.Close();
	  
	Network.AwakePanel(CtrlNames.Main);
	
	networkMgr:ShowLoading(true);
	networkMgr:SendBattleConnect();
	Network.SendBoxGetList();
end

function ResultCtrl.Close()
	panelMgr:ClosePanel(PanelNames.Result);
	bestList = {};
	resultData = {};
	MatchUserData = {};
	MainCtrl.UpdataPlayerInfoUI();
end