require "Common/define"


SelectRoleCtrl = {}

PlayersData = {};

RoleProtoConf = {};
--WeaponProtoConf = {};
SkillConf = {};

local this = SelectRoleCtrl;
local json = require "cjson"
local panel;
local selectrole;
local transform;
local gameObject;
local cdDesc = "倒计时";
local secondTxt = "秒";
local cdTimer = nil;
local cdTotal = 15;

local teamPlayersData = {};
local weapons = {};
local weaponlist = {};
local playerlist = {};
local currGameObject = nil;

function SelectRoleCtrl.New()
	logWarn("SelectRoleCtrl.New--->>");
	return this;
end

function SelectRoleCtrl.Awake()
	logWarn("SelectRoleCtrl.Awake--->>");
	panelMgr:CreatePanel('SelectRole', this.OnCreate);
	
	if transform then
		--transform:SetAsLastSibling();
	end

	if PlayerInfo ~= nil and next(PlayerInfo.weapons) then
		weapons = PlayerInfo.weapons;
		SelectRoleCtrl.OnCreateRoleList();
		SelectRoleCtrl.OnInitCDTimer();
	end
	
end

function SelectRoleCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;
	
	selectrole = transform:GetComponent('LuaBehaviour');
	logWarn("SelectRole lua--->>"..gameObject.name);

	selectrole:AddClick(SelectRolePanel.btnSure,this.OnSureClick);

	selectrole:AddClick(SelectRolePanel.btnSkill1,this.OnSkill1Click);
	selectrole:AddClick(SelectRolePanel.btnSkill2,this.OnSkill2Click);
	selectrole:AddClick(SelectRolePanel.btnSkill3,this.OnSkill3Click);
	
	--transform:SetAsLastSibling();
	SelectRoleCtrl.OnInitData();
	
end

function SelectRoleCtrl.OnInitData()
	--local roleProto = resMgr:LoadText("data","roleProto_conf_n");
	--LuaHelper.OnJsonCallFunc(roleProto, this.OnJsonCall);
	
	local weaponProto = resMgr:LoadText("data","weaponProto_conf_n");
	LuaHelper.OnJsonCallFunc(weaponProto, this.OnJsonCall);
	
	local skill = resMgr:LoadText("data","skill_conf_n");
	LuaHelper.OnJsonCallFunc(skill, this.OnJsonCall1);
end

function SelectRoleCtrl.OnJsonCall(data)
    local obj = json.decode(data);
	for index,v in pairs(obj) do
		table.insert(RoleProtoConf,v);
	end
	local _len = #RoleProtoConf;
    --print(obj['101']['protoId']);
end

function SelectRoleCtrl.OnJsonCall1(data)
    local obj = json.decode(data);
	for index,v in pairs(obj) do
		v.index = index;
		table.insert(SkillConf,v);
	end
	local _len = #SkillConf;
end

function SelectRoleCtrl.GetSkillDataByID(skillid)
	for _,v in ipairs(SkillConf) do
		if v.index == skillid then
			return v;
		end
	end
	return nil;
end

function SelectRoleCtrl.GetRoleDataByID(protoId)
	for _,v in ipairs(RoleProtoConf) do
		if v.protoId == protoId then
			return v;
		end
	end
	return nil;
end

function SelectRoleCtrl.GetWeaponDataByID(protoId)
	for _,v in ipairs(weapons) do
		if v.proto_id == protoId then
			return v;
		end
	end
	return nil;
end

function SelectRoleCtrl.ClearWeaponList()
	if next(weaponlist) then
		for _,v in pairs(weaponlist) do
			destroy(v);
		end
	end
end

function SelectRoleCtrl.OnInitCDTimer()
	if cdTimer == nil then
		cdTimer = Timer.New(this.SetDCDTimer,1,-1,true);
	end
	cdTimer:Start();
end

function SelectRoleCtrl.SetDCDTimer()
	cdTotal = cdTotal - 1;
	
	if cdTotal <= 0 then
		cdTotal = 0;
		SelectRolePanel.countdown:GetComponent('Text').text = "";
		if cdTimer then
			cdTimer:Stop();
			if SelectRolePanel.btnSure.activeSelf == true then
				--AppConst.WEAPONSKIN = 202001;
				--AppConst.WEAPONTYPE = 202;
				--logWarn("WEAPONSKIN:"..AppConst.WEAPONSKIN.." WEAPONTYPE:"..AppConst.WEAPONTYPE);
				--AppConst.WEAPONSKIN = AppConst.WEAPONTYPE*1000 + 1;
				--networkMgr:EnterSelectRole();
			end
		end
		return;
	end
	
	SelectRolePanel.countdown:GetComponent('Text').text = cdDesc..cdTotal..secondTxt;
	
end

function SelectRoleCtrl.OnCreateRoleList()
	SelectRoleCtrl.ClearWeaponList();
	SelectRoleCtrl.ClearPlayerList();
	
	resMgr:LoadPrefab('cell_hero', { 'Cell_Hero' }, this.InitPanel);
end

function SelectRoleCtrl.OnInitWeaponData()
	
end

function SelectRoleCtrl.InitPanel(objs)
	local count = #RoleProtoConf; --#weapons--#RoleProtoConf; 
	local parent = SelectRolePanel.gridParent;
	for i = 1, count do
		local go = newObject(objs[0]);
		go.name = "Item"..tostring(i);
		go.transform:SetParent(parent);
		go.transform.localScale = Vector3.one;
		go.transform.localPosition = Vector3.zero;
		local _btn = go.transform:FindChild("Btn_Portrait").gameObject;
		
		local _data = RoleProtoConf[i];--weapons[i];
		-- 10101 第二个的1代表角色类型,第三个的1代表角色皮肤
		local img = _btn:GetComponent('Image');
		local imgStr = "Weapon_".._data.prefabid;
		local sp = resMgr:LoadSprite(imgStr,imgStr);
		img.sprite = sp;
		
		local _id = _data.protoId - 200;
		_btn.name = tostring(_id);
        selectrole:AddClick(_btn, SelectRoleCtrl.OnSelectClick1);
		
		local _weapon = SelectRoleCtrl.GetWeaponDataByID(_data.protoId);
		local _btnlock = go.transform:FindChild("Locked").gameObject;
		if _weapon ~= nil then
			_btnlock:SetActive(false);
		else
			_btnlock:SetActive(true);
			local _txtlock = _btnlock.transform:FindChild("Text_Condition").gameObject:GetComponent('Text');
			if _data.protoId == 201 then
				_txtlock.text = "5级解锁";
			elseif _data.protoId == 203 then 
				_txtlock.text = "第二天登录解锁";
			end
		end
		
		if i == 1 then
			local _choose = _btn.transform:FindChild("Chosen").gameObject;
			_choose:SetActive(true);
			SelectRoleCtrl.SetRoleUI(_data.protoId,_data.prefabid);
			local _index = _data.protoId - 200;
			SelectRoleCtrl.SetSkillUI(_index);
			AppConst.WEAPONTYPE = 200 + _index;
			AppConst.WEAPONSKIN = _data.prefabid;
		end
		
		table.insert(weaponlist,go);
	end
end

function SelectRoleCtrl.SetRoleUI(protoId,skinid)
	local _data = SelectRoleCtrl.GetRoleDataByID(protoId);
		
	local _btn = SelectRolePanel.detailHero.transform:FindChild("Img_Class").gameObject;
	local img = _btn:GetComponent('Image');
	local imgStr = "Type_1";
	local sp = resMgr:LoadSprite(imgStr,imgStr);
	img.sprite = sp;
	
	local desc = SelectRolePanel.detailHero.transform:FindChild("Text_Desc").gameObject;
	local rname = SelectRolePanel.detailHero.transform:FindChild("Text_Rolename").gameObject;
	
	rname:GetComponent('Text').text = _data.name;
	desc:GetComponent('Text').text = _data.WeaponType;
	
	SelectRoleCtrl.SetWeaponSkinPreb(skinid);
	
	SelectRoleCtrl.SwitchRoleSkill()
end

function SelectRoleCtrl.SetWeaponSkinPreb(skin)
	if currGameObject ~= nil then
		destroy(currGameObject);
	end
	local prefabStr = "Model_"..skin;
	local prefab = resMgr:LoadPrefab(prefabStr,prefabStr);
	
	local parent = SelectRolePanel.weaponRoot;
	currGameObject = newObject(prefab);
	currGameObject.name = "Weapon"..skin;
	currGameObject.transform:SetParent(parent);
	currGameObject.transform.localScale = Vector3.one;
	currGameObject.transform.localPosition = Vector3.zero;
	currGameObject.transform.rotation = Vector3.zero;
end

function SelectRoleCtrl.SwitchRoleSkill()

	local _skillid1 = AppConst.WEAPONTYPE.."01";
	local _skilldata1 = SelectRoleCtrl.GetSkillDataByID(_skillid1);
	
	local _skillid2 = AppConst.WEAPONTYPE.."02";
	local _skilldata2 = SelectRoleCtrl.GetSkillDataByID(_skillid2);
	
	local _skillid3 = AppConst.WEAPONTYPE.."03";
	local _skilldata3 = SelectRoleCtrl.GetSkillDataByID(_skillid3);
	
	if _skilldata2 ~= nil and _skilldata3 ~= nil then
		local img1 = SelectRolePanel.btnSkill1:GetComponent('Image');
		SpriteManager.Instance:SetImage(img1,tostring("Skill_".._skilldata1.index),false);
		
		local img2 = SelectRolePanel.btnSkill2:GetComponent('Image');
		SpriteManager.Instance:SetImage(img2,tostring("Skill_".._skilldata2.index),false);
		
		local img3 = SelectRolePanel.btnSkill3:GetComponent('Image');
		SpriteManager.Instance:SetImage(img3,tostring("Skill_".._skilldata3.index),false);
	end
end

function SelectRoleCtrl.SetSkillUI(index)
	local _skillid = AppConst.WEAPONTYPE.."0"..index;
	local _skilldata = SelectRoleCtrl.GetSkillDataByID(_skillid);
	local skillname = SelectRolePanel.detailSkill.transform:FindChild("Text_Skill_Name").gameObject;
	local desc = SelectRolePanel.detailSkill.transform:FindChild("Text_Skill_Desc").gameObject;
	local cd = SelectRolePanel.detailSkill.transform:FindChild("Text_Skill_Condition").gameObject;
	skillname:GetComponent('Text').text = _skilldata.name;
	desc:GetComponent('Text').text = _skilldata.desc;
	cd:GetComponent('Text').text = "CD :".._skilldata.cd.." s";
end

function SelectRoleCtrl.OnSureClick(go)
	logWarn("click SelectRole button..........>>>>");
	
	SelectRolePanel.btnSure:SetActive(false);
	networkMgr:EnterSelectRole();
end

function SelectRoleCtrl.OnSelectClick1(go)
	
	if SelectRolePanel.btnSure.activeSelf == true then
		local _index = tonumber(go.name);
		AppConst.WEAPONTYPE = 200 + _index;
		
		logWarn("click select role button ......".._index.." WEAPONTYPE:"..AppConst.WEAPONTYPE);
		
		local _choose = go.transform:FindChild("Chosen").gameObject;
		_choose:SetActive(true);
		
		local _data = SelectRoleCtrl.GetWeaponDataByID(AppConst.WEAPONTYPE);--AppConst.WEAPONTYPE + 200;
		AppConst.WEAPONSKIN = _data.skin_id;
		SelectRoleCtrl.SetRoleUI(_data.proto_id,_data.skin_id);
		local _index = _data.proto_id - 200;
		SelectRoleCtrl.SetSkillUI(_index);
		--this.SetSelectRole(_index);
		this.HideOthers(_index);
	end

end

function SelectRoleCtrl.OnSkill1Click(go)
	
	SelectRoleCtrl.SetSkillUI(1)
end

function SelectRoleCtrl.OnSkill2Click(go)
	
	SelectRoleCtrl.SetSkillUI(2)
end

function SelectRoleCtrl.OnSkill3Click(go)
	
	SelectRoleCtrl.SetSkillUI(3)
end

function SelectRoleCtrl.SetSelectRole(index)
	--AppConst.ROLETYPE = index;	
	local _role = SelectRolePanel.heroTf:FindChild("player"..index).gameObject;
	local down = _role.transform:FindChild("down").gameObject;
	down:SetActive(true);
end

function SelectRoleCtrl.HideOthers(index)
	local count = #RoleProtoConf; 
	for i=1,count do
		local _data = RoleProtoConf[i];
		local _index = _data.protoId - 200;
		if _index ~= index then
			local _role = SelectRolePanel.gridParent:FindChild("Item"..i).gameObject;
			local _btn = _role.transform:FindChild(_index).gameObject;
			local _choose = _btn.transform:FindChild("Chosen").gameObject;
			_choose:SetActive(false);
		end
	end
end

function SelectRoleCtrl.OnUpdateRoleReadyOk(userindex,roleType,skin)
	local _data = {};
	_data.userindex = userindex;
	_data.roleType = roleType;
	_data.skin = skin;

	table.insert(PlayersData,_data);
	
	local _index,_data = MainCtrl.GetMatchPlayerByIndex(userindex);
	if _data.team == SelfTeam then
		table.insert(teamPlayersData,_data);
		this.SetPlayerReady(#teamPlayersData,true,userindex,skin);
	end

end

function SelectRoleCtrl.GetPlayerDataByID(userindex)
	for _,v in ipairs(PlayersData) do
		if v.userindex == userindex then
			return v;
		end
	end
	return nil;
end

function SelectRoleCtrl.SetPlayerReady(index,isVisiable,userindex,skin)
	local _playerList = SelectRolePanel.playerList;
	local _tf = _playerList.transform;
	
	local user = _tf:FindChild("Player_"..index).gameObject;
	local icon = user.transform:FindChild("Img_Portrait").gameObject;
	local name = user.transform:FindChild("Text_Nickname").gameObject;
	local ready = user.transform:FindChild("Ready").gameObject;

	icon:SetActive(true);
	ready:SetActive(isVisiable);
	name:SetActive(true);
	
	-- 10101 第二个的1代表角色类型,第三个的1代表角色皮肤
	local img = icon:GetComponent('Image');
	--roleType = roleType + 100;
	local imgStr = "Weapon_"..skin;
	local sp = resMgr:LoadSprite(imgStr,imgStr);
	img.sprite = sp;
	
	
	local _data = SelectRoleCtrl.GetUserName(userindex);
	name:GetComponent('Text').text = _data.nickname;--AppConst.USERNAME;

	table.insert(playerlist,user);
end

function SelectRoleCtrl.ClearPlayerList()
	for index,user in pairs(playerlist) do
		local icon = user.transform:FindChild("Img_Portrait").gameObject;
		local name = user.transform:FindChild("Text_Nickname").gameObject;
		local ready = user.transform:FindChild("Ready").gameObject;
		
		icon:SetActive(false);
		ready:SetActive(false);
		name:SetActive(false);
	end
end

function SelectRoleCtrl.GetUserName(userindex)
	
	local _mylen = #MyTeamUsers;
	local _enlen = #EnemyTeamUsers;
	
	for i=1,_mylen do
		if userindex == MyTeamUsers[i].userindex then
			return MyTeamUsers[i];
		end
	end
	
	for j=1,_enlen do
		if userindex == EnemyTeamUsers[j].userindex then
			return EnemyTeamUsers[j];
		end
	end
	
	return nil;
end

function SelectRoleCtrl.Close()
	panelMgr:ClosePanel(PanelNames.SelectRole);
	teamPlayersData = {};
	SelectRolePanel.btnSure:SetActive(true);
	if cdTimer then
		cdTimer:Stop();
		cdTotal = 15;
	end
end