require "Common/define"

SevenDayLoginCtrl = {}
-- 是否领取过
isReceived = false;

local this = SevenDayLoginCtrl;
local panel;
local sevendaylogin;
local transform;
local gameObject;
local _currLoginDay = 1;

function SevenDayLoginCtrl.New()
	logWarn("SevenDayLoginCtrl.New--->>");
	return this;
end

function SevenDayLoginCtrl.Awake()
	logWarn("SevenDayLoginCtrl.Awake--->>");
	panelMgr:CreatePanel('SevenDayLogin', this.OnCreate);
end

function SevenDayLoginCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;

	-- panel = transform:GetComponent('UIPanel');
	sevendaylogin = transform:GetComponent('LuaBehaviour');
	logWarn("SevenDayLogin lua--->>"..gameObject.name);

	this.InitPanel();	
	
	sevendaylogin:AddClick(SevenDayLoginPanel.btnReceive,this.OnReceiveClick);

	if PlayerInfo ~= nil then
		_currLoginDay = SevenDayData.day;
		this.OnInitDayUI();
	end
end

function SevenDayLoginCtrl.GetSevenDayData(day)
	if next(SevenDayLoginConf) then
		for index,v in pairs(SevenDayLoginConf) do
			if v.day == day then
				return v;
			end
		end
	end
	return nil;
end

function SevenDayLoginCtrl.OnInitDayUI()
	if next(SevenDayLoginConf) then
		for index,v in pairs(SevenDayLoginConf) do
			SevenDayLoginCtrl.SetDayUI(v,index);
		end

		SevenDayLoginPanel.labDay:GetComponent('Text').text = _currLoginDay;
	end
end

function SevenDayLoginCtrl.SetDayUI(dayData)
	if dayData ~= nil then
		local _index = dayData.day - 1;
		local _day = SevenDayLoginPanel.preview.transform:FindChild("Day_".._index).gameObject;
		local _icon = _day.transform:FindChild("Btn_Icon").gameObject;
		local img = _icon:GetComponent('Image');
		
		local imgStr = SevenDayLoginCtrl.GetSevenDayIcon(dayData);
		local sp = resMgr:LoadSprite(imgStr,imgStr);
		img.sprite = sp;

		local _nameStr,_num = SevenDayLoginCtrl.GetSevenDayItemNameCount(dayData);
		
		local _name = _day.transform:FindChild("Txt_Name").gameObject;
		_name:GetComponent('Text').text = _nameStr;
		
		local _count = _day.transform:FindChild("Txt_Num").gameObject;
		if _num > 1 then
			_count:GetComponent('Text').text = _num;
		else
			_count:GetComponent('Text').text = "";
		end
		
		local _today = _day.transform:FindChild("Today").gameObject;
		if SevenDayData.day == dayData.day then
			_today:SetActive(true);
		end
		
		if (SevenDayData.day > dayData.day) then
			local _claimed = _day.transform:FindChild("Claimed").gameObject;
			_claimed:SetActive(true);
			_today:SetActive(false);
		end

	end
end

function SevenDayLoginCtrl.GetSevenDayItemNameCount(dayData)
	local _nameStr = dayData.des;

	local _count = 1;
	if dayData.type == "gold" or dayData.type == "diamond" then
		if dayData.type == "gold" then
			_count = dayData.gold;
		else
			_count = dayData.diamond;
		end
	end
	
	return _nameStr,_count;
end

function SevenDayLoginCtrl.GetSevenDayIcon(dayData)
	local imgStr = "Item_Money_A";
		
	if dayData.type == "diamond" then
		imgStr = "Item_Money_B";
	elseif dayData.type == "skin" then
		if PlayerInfo.sex == 1 then
			imgStr = "Avatar_"..dayData.skin[1];
		else
			imgStr = "Avatar_"..dayData.skin[2];
		end
	elseif dayData.type == "weapon" then
		imgStr = "Weapon_"..dayData.weapon.."001";
	end
	return imgStr;
end

function SevenDayLoginCtrl.InitPanel()

end

function SevenDayLoginCtrl.OnReceiveClick(go)
	logWarn("click receive button..........>>>>");
	local _currDay = SevenDayData.day;
	
	if isReceived then
		QuickTips.ShowYellowQuickTips("今日奖励已领取，明天记得来看看哦~");
	else
		Network.SendReceiveSevenDayReward(SevenDayData.day);
	end
end

function SevenDayLoginCtrl.UpdateReceiveStatus(status)
	isReceived = status;
end

function SevenDayLoginCtrl.UpdateSevenDayUI(reward)

	isReceived = true;
	
	-- 领取奖励
	if reward then
		
		if reward.type == "skin" then
			-- 获得时装
			DataEntry.roleModel:AddAvatarItemByID(reward.skin);
		elseif reward.type == "weapon" then 
			-- 解锁武器
		elseif reward.type == "gold" then
			MainCtrl.UpdataPlayerInfoUI(); 
		end

		local _dataDay = this.GetSevenDayData(SevenDayData.day);
		local _imgStr = this.GetSevenDayIcon(_dataDay);
		local _nameStr,_count = this.GetSevenDayItemNameCount(_dataDay);
		QuickTips.ShowItemQuickTips(_imgStr,_nameStr,_count);

	end
	
	
	-- 重置领取状态
	if SevenDayData.day >= 7 then
		MainCtrl.CloseSevenDayBtn();
		local _day = SevenDayLoginPanel.preview.transform:FindChild("Day_6").gameObject;
		local _claimed = _day.transform:FindChild("Claimed").gameObject;
		_claimed:SetActive(true);
		_today:SetActive(false);
	else
		SevenDayData.day = SevenDayData.day + 1;
		SevenDayData.canreward = false;
		MainCtrl.OnInitSevenDayUI();
		SevenDayLoginCtrl.OnInitDayUI();
	end
	
	
end

function SevenDayLoginCtrl.Close()
	panelMgr:ClosePanel(PanelNames.SevenDayLogin);
end