require "Common/define"

WeaponCtrl = {}

local this = WeaponCtrl;

local panel;
local weapon;
local transform;
local gameObject;
local json = require "cjson"
local WeaponSkins = {};
local weaponID = 201;
local skinID = 201001;
local currGameObject = nil;
local count = 0; 
local weaponskinlist = {};
local skinlist = {};

function WeaponCtrl.New()
	logWarn("WeaponCtrl.New--->>");
	return this;
end

function WeaponCtrl.Awake()
	logWarn("WeaponCtrl.Awake--->>");
	panelMgr:CreatePanel('Weapon', this.OnCreate);
	WeaponCtrl.UpdataPlayerInfoUI();
end

function WeaponCtrl.OnCreate(obj)
	gameObject = obj;
	transform = obj.transform;

	-- panel = transform:GetComponent('UIPanel');
	weapon = transform:GetComponent('LuaBehaviour');
	logWarn("Weapon lua--->>"..gameObject.name);

	weapon:AddClick(WeaponPanel.btnBack,this.Close);
	
	weapon:AddClick(WeaponPanel.btnSelectWeapon1,this.OnClickWeapon1);
	weapon:AddClick(WeaponPanel.btnSelectWeapon2,this.OnClickWeapon2);
	weapon:AddClick(WeaponPanel.btnSelectWeapon3,this.OnClickWeapon3);
	
	WeaponCtrl.OnInitSkinData();
	
	WeaponCtrl.OnClickWeapon2();
	WeaponCtrl.OnCreateWeaponSkinList();
	
end

function WeaponCtrl.OnInitSkinData()
	local skinProto = resMgr:LoadText("data","weaponskin");
	LuaHelper.OnJsonCallFunc(skinProto, this.OnJsonCall);
end

function WeaponCtrl.OnJsonCall(data)
    local obj = json.decode(data);
	for index,v in pairs(obj) do
		v.index = index;
		table.insert(WeaponSkins,v);
	end
	local _len = #WeaponSkins;
    --print(obj['101']['protoId']);
end

function WeaponCtrl.UpdataPlayerInfoUI()
	if PlayerInfo then
		local _gold = WeaponPanel.Money.transform:FindChild("Money_A/Text").gameObject;
		_gold:GetComponent('Text').text = PlayerInfo.gold;
	end
end
function WeaponCtrl.OnClickWeapon1()
	skinID = 201001;
	weaponID = 201;
	WeaponCtrl.SetWeaponUI(WeaponPanel.btnSelectWeapon1,skin,1,true)
	WeaponCtrl.SetWeaponSkinPreb(skinID);
	
	WeaponCtrl.OnCreateWeaponSkinList();
end

function WeaponCtrl.OnClickWeapon2()
	skinID = 202001;
	weaponID = 202;
	WeaponCtrl.SetWeaponUI(WeaponPanel.btnSelectWeapon2,skin,2,true)
	WeaponCtrl.SetWeaponSkinPreb(skinID);
	
	WeaponCtrl.OnCreateWeaponSkinList();
end

function WeaponCtrl.OnClickWeapon3()
	skinID = 203001;
	weaponID = 203;
	WeaponCtrl.SetWeaponUI(WeaponPanel.btnSelectWeapon3,skin,3,true)
	WeaponCtrl.SetWeaponSkinPreb(skinID);
	
	WeaponCtrl.OnCreateWeaponSkinList();
end

function WeaponCtrl.SetWeaponUI(weapon,skin,index,isActive)
	WeaponCtrl.SetSelectUI(weapon,isActive);
	WeaponCtrl.OnHideOthers(index);
end

function WeaponCtrl.SetSelectUI(weapon,isActive)
	local tf = weapon.transform;
	
	local chosen = tf:FindChild("Chosen").gameObject;
	--local mark = tf:FindChild("Mark").gameObject;
	
	chosen:SetActive(isActive);
	
	--if skin == skinID then
	--mark:SetActive(isActive);
	--end
end

function WeaponCtrl.OnHideOthers(index)
	if index == 1 then
		WeaponCtrl.SetSelectUI(WeaponPanel.btnSelectWeapon2,false);
		WeaponCtrl.SetSelectUI(WeaponPanel.btnSelectWeapon3,false);
	elseif index == 2 then
		WeaponCtrl.SetSelectUI(WeaponPanel.btnSelectWeapon1,false);
		WeaponCtrl.SetSelectUI(WeaponPanel.btnSelectWeapon3,false);
	else
		WeaponCtrl.SetSelectUI(WeaponPanel.btnSelectWeapon2,false);
		WeaponCtrl.SetSelectUI(WeaponPanel.btnSelectWeapon1,false);
	end
	
end

function WeaponCtrl.SetWeaponSkinPreb(skin)
	if currGameObject ~= nil then
		destroy(currGameObject);
	end
	
	local prefabStr = "Model_"..skin;
	local prefab = resMgr:LoadPrefab(prefabStr,prefabStr);
	local parent = WeaponPanel.weaponRoot;
	currGameObject = newObject(prefab);
	currGameObject.name = "Weapon"..skin;
	currGameObject.transform:SetParent(parent);
	currGameObject.transform.localScale = Vector3.one;
	currGameObject.transform.localPosition = Vector3.zero;
	currGameObject.transform.rotation = Vector3.zero;
end

function WeaponCtrl.OnCreateWeaponSkinList()
	resMgr:LoadPrefab('cell_weapon_skin', { 'Cell_Weapon_Skin' }, this.InitPanel);
end

function WeaponCtrl.ClearWeaponSkinList()
	if next(weaponskinlist) then
		for _,v in pairs(weaponskinlist) do
			destroy(v);
		end
	end
end

function WeaponCtrl.GetWeaponSkinList()
	local _list = {};
	for index,v in pairs(WeaponSkins) do
		if v.weapontype == weaponID then
			table.insert(_list,v);
		end
	end
	table.sort(_list,function(a,b)
		return a.skinid < b.skinid
	end)
	return _list;
end

function WeaponCtrl.InitPanel(objs)
		
	WeaponCtrl.ClearWeaponSkinList();
	skinlist = WeaponCtrl.GetWeaponSkinList();
	count = #skinlist;
	local parent = WeaponPanel.skinp;
	for i = 1, count do
		
		local _data = skinlist[i];
		
		local go = newObject(objs[0]);
		local _skin = _data.weapontype.."00".._data.skinid;
		go.name = _data.index;
		go.transform:SetParent(parent);
		go.transform.localScale = Vector3.one;
		go.transform.localPosition = Vector3.zero;

		local _weapon = go.transform:FindChild("Img_Icon").gameObject;
		-- 10101 第二个的1代表角色类型,第三个的1代表角色皮肤
		local img = _weapon:GetComponent('Image');
		local imgStr = "Weapon_".._data.index;
		local sp = resMgr:LoadSprite(imgStr,imgStr);
		img.sprite = sp;
		
        weapon:AddClick(go, WeaponCtrl.OnSelectClick);
		
		if i == 1 then
			WeaponCtrl.SetSelectUI(go,true)
			WeaponCtrl.SetWeaponSkinPreb(_skin);
			WeaponCtrl.OnSetSkinUI(_skin)
		end
		
		table.insert(weaponskinlist,go);
		
	end

end

function WeaponCtrl.OnSelectClick(go)
	local _skin = tonumber(go.name);
	WeaponCtrl.HideOthers(_skin);
	WeaponCtrl.SetSelectUI(go,true);
	WeaponCtrl.SetWeaponSkinPreb(_skin);
	WeaponCtrl.OnSetSkinUI(_skin)
end

function WeaponCtrl.GetWeaponSkinData(skinid)
	for index,v in pairs(WeaponSkins) do
		if v.id == tostring(skinid) then
			return v;
		end
	end
	return nil;
end

function WeaponCtrl.OnSetSkinUI(skinid)
	logWarn("skinid:"..skinid);
	local _skinData = WeaponCtrl.GetWeaponSkinData(skinid)
	if _skinData then
		WeaponPanel.skinName:GetComponent('Text').text = _skinData.name;
		WeaponPanel.skinDesc:GetComponent('Text').text = _skinData.desc;
	else
		logWarn("数据异常!")
	end
end

function WeaponCtrl.HideOthers(index)
	local count = #skinlist; 
	for i=1,count do
		local _data = skinlist[i];
		if _data.index ~= index then
			local _skin = WeaponPanel.skinp:FindChild(tostring(_data.index)).gameObject;
			WeaponCtrl.SetSelectUI(_skin,false);
		end
	end
end

function WeaponCtrl.Close()
	panelMgr:ClosePanel(PanelNames.Weapon);
end