require "Common/define"
require "Controller/PromptCtrl"
require "Controller/MessageCtrl"
require "Controller/LoginCtrl"
require "Controller/MainCtrl"
require "Controller/MatchCtrl"
require "Controller/SelectRoleCtrl"
require "Controller/LoadResourceCtrl"
require "Controller/ResultCtrl"
require "Controller/CharaCreationCtrl"
require "Controller/WeaponCtrl"
require "Controller/InfoCtrl"
require "Controller/RankCtrl"
require "Controller/SevenDayLoginCtrl"

CtrlManager = {};
local this = CtrlManager;
local ctrlList = {};	--控制器列表--

function CtrlManager.Init()
	logWarn("CtrlManager.Init----->>>");
	--ctrlList[CtrlNames.Prompt] = PromptCtrl.New();
	--ctrlList[CtrlNames.Message] = MessageCtrl.New();
	ctrlList[CtrlNames.Login] = LoginCtrl.New();
	ctrlList[CtrlNames.Main] = MainCtrl.New();
	ctrlList[CtrlNames.Match] = MatchCtrl.New();
	ctrlList[CtrlNames.SelectRole] = SelectRoleCtrl.New();
	ctrlList[CtrlNames.LoadResource] = LoadResourceCtrl.New();
	ctrlList[CtrlNames.Result] = ResultCtrl.New();
	ctrlList[CtrlNames.CharaCreation] = CharaCreationCtrl.New();
	ctrlList[CtrlNames.Info] = InfoCtrl.New();
	ctrlList[CtrlNames.Weapon] = WeaponCtrl.New();
	ctrlList[CtrlNames.Rank] = RankCtrl.New();
	ctrlList[CtrlNames.SevenDayLogin] = SevenDayLoginCtrl.New();
	return this;
end

--添加控制器--
function CtrlManager.AddCtrl(ctrlName, ctrlObj)
	ctrlList[ctrlName] = ctrlObj;
end

--获取控制器--
function CtrlManager.GetCtrl(ctrlName)
	return ctrlList[ctrlName];
end

--移除控制器--
function CtrlManager.RemoveCtrl(ctrlName)
	ctrlList[ctrlName] = nil;
end

--关闭控制器--
function CtrlManager.Close()
	logWarn('CtrlManager.Close---->>>');
end