
require "Common/define"
require "Common/protocal"
require "Common/functions"
Event = require 'events'

require "3rd/pblua/login_pb"
require "3rd/pbc/protobuf"

local sproto = require "3rd/sproto/sproto"
local core = require "sproto.core"
local print_r = require "3rd/sproto/print_r"
local crypt = require "crypt"
local message = require "3rd/sproto/sprotomessage"
local battlemessage = require "3rd/sproto/sprotobattlemessage"
local spevent = require "3rd/sproto/sprotoevent"
local spbattleevent = require "3rd/sproto/sprotobattleevent"
local json = require "cjson" 


Network = {};
local this = Network;

local transform;
local gameObject;
local islogging = false;
local challage;
local clientkey;
local protocalKey;
local timer;
local timer1;

loadCount = 1;
reconnetCount = 1;
local openId = AppConst.DEVID;
local channelName = "euplay";
local tokenValue = "password";
local openName  = "4399eu"
local secretstrKey;

local pingthreshould;
local isEnterGame = false;
local isDisconnect = false;

function Network.Start() 
    logWarn("Network.Start!!");
    Event.AddListener(Protocal.Connect, this.OnConnect); 
    Event.AddListener(Protocal.Message, this.OnMessage); 
    Event.AddListener(Protocal.Exception, this.OnException); 
    Event.AddListener(Protocal.Disconnect, this.OnDisconnect); 
	
	Event.AddListener(Protocal.ConnectGame, this.OnConnectGame);
	
	Event.AddListener(Protocal.ConnectBattle, this.OnConnectBattle);
	Event.AddListener(Protocal.BattleException, this.OnBattleException); 
    Event.AddListener(Protocal.BattleDisconnect, this.OnBattleDisconnect);
	
	Event.AddListener(Protocal.RoomBattleLogin, this.OnRoomLoginFaile); 
	
	Event.AddListener(Protocal.RoomLoginTimeOut, this.OnRoomLoginTimeOut);
	Event.AddListener(Protocal.RoomSendDisConnect, this.OnRoomSendDisConnect); 
    Event.AddListener(Protocal.RoomReceiveDisConnect, this.OnRoomReceiveDisConnect);
	
	Event.AddListener(Protocal.Challage,this.OnChallage);
	Event.AddListener(Protocal.Secret,this.OnSecret);
	Event.AddListener(Protocal.Token,this.OnToken);
	Event.AddListener(Protocal.RawrRecv,this.OnRawrRecv);
end

--Socket消息--
function Network.OnSocket(key, data)
	if key >= tonumber(Protocal.GameLogin) and AppConst.isLoginGame == true then
		local _key = key;
		message.receive(data);
	else
		if reconnetCount > 1 then
			if key == Protocal.ConnectGame then
				key = Protocal.ConnectGame;
			else
				key = 204;
			end
			
		end
		Event.Brocast(tostring(key), data);
	end
	
end

--当登录连接建立时--
function Network.OnConnect() 
    logWarn("Game Server Login connected!!");
	
end

--当游戏服务器连接建立时--
function Network.OnConnectGame() 
    logWarn("Game Server Main connected!!");

	if AppConst.iSwitchUser then
		logWarn("swich user......");
		loadCount = 1;
	else
		if isEnterGame then
			logWarn("again sproto......");
			loadCount = loadCount + 1;
			AppConst.isLoginGame = false;
			reconnetCount = reconnetCount + 1;
		else
			message.register()
			message.bind({},spevent)
			logWarn("init sproto......")
			isEnterGame = true;
		end
	end
	
	
	local versionName = DataEntry.loginModel.version;
	local _openid = DataEntry.loginModel.platformUid;
	local _channelName = DataEntry.loginModel.platformName

	logWarn(">>>>>>>>>_openid:".._openid);
	logWarn(">>>>>>>>>_openid:"..versionName);
	-- 构建登录消息 格式 openId : 渠道名称 : 版本号 : 登陆次数
	local msg = crypt.base64encode(_openid).. ":"..crypt.base64encode(_channelName).. ":" ..crypt.base64encode(versionName).. ":" ..crypt.base64encode(loadCount)
	
	local buffer = ByteBuffer.New();
	buffer:WriteUnShortBuffer(msg);
	networkMgr:SendMessage(buffer);
	
	
end

--游戏服务器返回数据成功进入主UI--
function Network.OnRawrRecv(buffer)
	local str = buffer:ReadString();
	log("recv code："..str);
	
	local tipStr="";
	if str == "403" then
		tipStr="版本过低";
	elseif str == "406" then
		tipStr="断线重连序号错误";
	elseif str == "408" then
		tipStr="登陆令牌过期";
	end
	if tipStr ~= "" then
		networkMgr:ShowLoading(false);
		isEnterGame = false;
		QuickTips.ShowYellowQuickTips(tipStr);
		return;
	end

	
	local base64Ret = crypt.base64decode(str)

    local code, isencrypt, debugAddRes, threshould = base64Ret:match("(%d+)%s(%a+)%s(%a+)%s(%d+)")

    if code == nil then
        --app:showTips("Handshake failed: code nil"..tostring(str))
		QuickTips.ShowYellowQuickTips("Handshake错误码为空!");
        return;
    end
    --[[if code ~= "200" then
        --app:showTips("Handshake failed:" .. code)
		QuickTips.ShowYellowQuickTips("Handshake错误码:"..code);
        return;
    end--]]
	
	-- 心跳超时阈值
    pingthreshould = tonumber(threshould)
	log("pingthreshould:"..pingthreshould);

    -- 是否需要加密
    if isencrypt == "true" then
        message.setsecret(secretstrKey)
    end
	
	AppConst.isLoginGame = true;
	
	islogging = true;
	
	this.login();
end

-- 登录游戏 --
function Network.login()
    local platform = DataEntry.loginModel.platformName;--"Window"--device.platform,
	local devid = AppConst.DEVID;--DeviceID,
	local nettype = DataEntry.loginModel.nm;--device.getNetworkStatus(),
	local resolution = DataEntry.loginModel.screen;--device.getResolutionRatio(),
	local imei = DataEntry.loginModel.imei;
	local operator = DataEntry.loginModel.mno;--device.getOperators(),
	local mac =  DataEntry.loginModel.macadd;
	local os = DataEntry.loginModel.osVersion; --device.getAndroidOSVersion(),
	local model = DataEntry.loginModel.deviceName; --device.getDeviceModel(),
	message.request("user_login",{platform = platform,devid = devid,nettype = nettype,resolution = resolution,imei = imei,operator = operator,mac = mac,os = os,model = model});

end

-- 返回第一次握手的挑战码并返回客户端 8 字节长的随机串发给服务器
function Network.OnChallage(buffer)
	local str = buffer:ReadUnShortString();
	log("original code："..str);
	
	local from = str:find("\n", 1, true)
	if from then
		local line = str:sub(1, from-1)
		print("line:"..line);
		str = str:sub(from+1)
		challage = crypt.base64decode(line)
		
		print("challage:"..challage);
		
		clientkey = crypt.randomkey()
		local _clietA = crypt.dhexchange(clientkey)
		-- 客户端 8 字节长的随机串发给服务器，用于交换 secret 的 key 。
		local swap = crypt.base64encode(_clietA).."\n"
		local buffer = ByteBuffer.New();
		buffer:WriteUnShortString(swap);
		networkMgr:SendMessage(buffer);
	end
end

-- 返回服务器秘钥并交互SDK,发送token请求--
function Network.OnSecret(buffer)
	local str = buffer:ReadUnShortString();
	log("Secret code："..str);
	
	local from = str:find("\n", 1, true)
	if from then
		local line = str:sub(1, from-1)
		str = str:sub(from+1)
		
		local secretStr = crypt.base64decode(line)
		
		print("secretStr is ", secretStr)
		local secret = crypt.dhsecret(secretStr, clientkey)
		print("secret is ", crypt.hexencode(secret))
		
		secretstrKey = secret
	
		-- 回应服务器第一步握手的挑战码，确认握手正常
		local hmac = crypt.hmac64(challage, secret)
		local swap = crypt.base64encode(hmac).."\n"
		local buffer = ByteBuffer.New();
		buffer:WriteUnShortString(swap);
		networkMgr:SendMessage(buffer);
		
		local _openid = DataEntry.loginModel.platformUid;
		print("penid:",_openid)
		local _openname = DataEntry.loginModel.platformUserName;
		print("_openname:",_openname)
		local _ext = DataEntry.loginModel.platformExt;
		print("_ext:",_ext)
		local _channelName = DataEntry.loginModel.platformName;
		print("_channelName:",_channelName)
		-- user ,channel ,token 需要通过SDK交互取得
		local pass = {
			user = _openid,
			channel = _channelName,
			openname = _openname,
			token = _ext,
		}
		
		local function encode_token(pass)
			return string.format("%s@%s@%s:%s",
				crypt.base64encode(pass.user),
				crypt.base64encode(pass.openname),
				crypt.base64encode(pass.channel),
				crypt.base64encode(pass.token))
		end
		
		-- 发送token请求
		-- 使用 DES 算法，以 secret 做 key 加密传输 token 串
		local epass = crypt.desencode(secret, encode_token(pass))
		local swapass = crypt.base64encode(epass).."\n"
		print("swapass:"..swapass)
		local buffer = ByteBuffer.New();
		buffer:WriteUnShortString(swapass); -- WriteUnShortString
		networkMgr:SendMessage(buffer);
		
	end
end
local function split(s, sep)
	local ret = {}
	if type(s) == "string" and type(sep) == "string" and string.len(sep) > 0 then
		-- for match in (s..sep):gmatch("(.-)"..sep) do
		-- 	table.insert(ret, match)
		-- end
		while true do
			local pos = string.find(s, sep)
			if not pos then
				table.insert(ret, s)
				break
			end
			table.insert(ret, string.sub(s, 1, pos - 1))
			s = string.sub(s, pos + 1)
		end
	end
	return ret
end
-- 返回token数据,开始登录游戏服务器--
function Network.OnToken(buffer)
	local str = buffer:ReadUnShortString();
	log("Secret code："..str);
	
	local from = str:find("\n", 1, true)
	if from then
		local result = str:sub(1, from-1)
		str = str:sub(from+1)
		print("result:"..result)
		local ret=split(result," ")
		--local code = tonumber(string.sub(result, 1, 3))
		local code = tonumber(ret[1])
		if code == 200 then
			-- 关闭登录socket
			-- socket.close()
			networkMgr:CloseConnect();
			local uid=crypt.base64decode(ret[2])
			networkMgr:LogLoginFinish(uid)
			local subid=crypt.base64decode(ret[3])
			--local subid = crypt.base64decode(string.sub(result, 5))
			print("login ok, subid=", subid)
			local splitlist = {}
			string.gsub(subid, '[^:]+', function(w) table.insert(splitlist, w) end )
			local port = string.format("端口：%d", splitlist[2])
			if next(splitlist) then
				
				-- self:connectGameServer(splitlist[1],splitlist[2])
				print("游戏服务器地址:")
				print("ip:"..splitlist[1])
				print("port:"..splitlist[2])
				
				AppConst.SocketPort = splitlist[2]; 
				AppConst.SocketAddress = splitlist[1];
				AppConst.SocketConnetType = NetConnectTpye.GameMain;
				networkMgr:SendGameConnect();

			end
		else
			log("登录返回失败...")
			QuickTips.ShowYellowQuickTips("登录失败,错误码:"..code);
		end
		
	end
end


function Network.SendRoomServer()
	log("send SendRoomServer....");
	message.request("global_roomserver",{});
end

function Network.SendPingServer()
	if islogging then
		--log("send SendPingServer....");
		message.request("global_ping",{});
	end
	
end

function Network.Start_Ping()
	--log("===>>>> Start_Ping......");
	message.request("global_ping",{});
	timer = Timer.New(this.SendPingServer, pingthreshould, -1, true);
	timer:Start();
end

function Network.SendPlayerInfo()
	log("send SendPlayerInfo....");
	message.request("user_info",{});
end

function Network.CreatePlayer(name,sex)
	log("send CreatePlayer....");
	--nickname 0 : string
	--	sex 1 : integer
	message.request("user_create",{nickname = name,sex = sex});
end

-- 发送购买玩家皮肤 --
function Network.SendBuyRoleSkin(skins)
	local _skins = json.decode(skins);
	message.request("user_buyroleskin",{skins = _skins});
end

-- 发送玩家皮肤保存 --
function Network.SendSaveRoleSkins(skins)
	local _skins = json.decode(skins);
	message.request("user_saveroleskins",{skins = _skins});
end

-- 发送游戏账号登出 --
function Network.SendUserLoginOut()
	log("send SendUserLoginOut....");
	--message.request("user_logout",{});
	-- 执行SDK 账号登出
	networkMgr:GameLoginOut();
end

-- 排行榜列表 mode 代表rob ; rtype 每日 day, 赛季 season --
function Network.SendRankList(mode,rtype)
	log("send ranklist....");
	message.request("rank_getlist",{mode = mode , type = rtype});
end

-- 获取排行榜的角色形象 --
function Network.SendUserFigure(userid)
	log("send user figure....");
	message.request("rank_getuserskins",{userid = userid});
end

-- 获取宝箱列表数据
function  Network.SendBoxGetList()
 	log("box  getlist ....");
 	message.request("box_getlist",{});
end

-- 宝箱解锁-- 
function Network.SendBoxUnlock(boxindex,boxid)
	log("Send Box Unlock....");
	message.request("box_unlock",{boxindex = boxindex,boxid = boxid});
end

-- 宝箱开箱
function Network.SendBoxOpen(boxindex,boxid)
	log("Send Box Open....");
	message.request("box_open",{boxindex = boxindex,boxid = boxid})
end

-- 获取七日登录的数据 --
function Network.SendSevenDayData()
	log("send get sevenday ....");
	message.request("activity_newbierewardstatus",{});
end

-- 领取七日登录的奖励 --
function Network.SendReceiveSevenDayReward(currday)
	log("send recevie sevenday reward ....");
	message.request("activity_newbiegetreward",{day = currday});
end

----------------------  ui start   ----------------------

--打开匹配进入界面--
function Network.OnOpenMatchPanel()
	MainCtrl.HideTest();
	Network.AwakePanel(CtrlNames.Match)
end

--同时激活login和main--
function Network.InitAwakePanel()
	if AppConst.SocketConnetType == 1 then
		Network.AwakePanel(CtrlNames.Login)
		Network.OpenPartPanel()
	end
	
	--Network.AwakePanel(CtrlNames.Main)
end

--打开主界面--
function Network.OnOpenMainPanel()
	Network.AwakePanel(CtrlNames.Main)
end

function Network.OnCreatePanel()
	coroutine.start(this.OpenPartPanel);
end

--创建打开部分面板--
function Network.OpenPartPanel()

--[[	logWarn("open_coroutine...");
	coroutine.wait(2);--]]
	
	Network.AwakePanel(CtrlNames.SelectRole);
	Network.AwakePanel(CtrlNames.LoadResource);
	
	SelectRoleCtrl.Close();
	LoadResourceCtrl.Close();
	local sp = SpriteManager.Instance;
end

-- 激活 --
function Network.AwakePanel(name)
	local ctrl = CtrlManager.GetCtrl(name);
    if ctrl ~= nil then
        ctrl:Awake();
    end
end

-- 匹配玩家数据
function Network.GetMatchUserData(userid,nickname,userindex,icon,ready,team,sex)
	MatchCtrl.SetUsersData(userid,nickname,userindex,icon,ready,team,sex);
end

function Network.InitMatchData()
	MatchCtrl.initData();
end

-- 匹配后入玩家数据
function Network.GetAfterMatchUserData(userid,nickname,userindex,icon,ready,team,sex)
	MatchCtrl.SetUserData(userid,nickname,userindex,icon,ready,team,sex);
end

-- 准备返回状态 --
function Network.SetMatchStatus(userindex)
	MatchCtrl.OnUpdateMatchStatus(userindex);
end

-- 准备返回状态 --
function Network.StartSelectRoleCD()
	MatchCtrl.OnStartSelectRoleCD();
end

-- 选择完角色的玩家数据 --
function Network.GetPlayerReadyOK(userindex,roletype,skin)
	SelectRoleCtrl.OnUpdateRoleReadyOk(userindex,roletype,skin);
end

-- 进入资源加载界面 --
function Network.EnterLoadResourcePanel()
	SelectRoleCtrl.Close();
	Network.AwakePanel(CtrlNames.LoadResource)
end

-- 更新资源加载进度 --
function Network.UpdateLoadResProgress(userindex,progress)
	LoadResourceCtrl.OnUpdateOtherProgress(userindex,progress)
end

--打开结算界面--
function Network.OnOpenResultPanel()
	Network.AwakePanel(CtrlNames.Result);
end

--获取结算数据--
function Network.SetResultData(addexp,addgold,newexp,newlv,maxexp,win,boxid)

	ResultCtrl.SetResultData(addgold,addexp,newlv,newexp,maxexp,win,boxid);
end

--获取最高成就数据--
function Network.SetBestInfo(index,best,best_value)
	ResultCtrl.SetBestInfo(index,best,best_value);
end

--显示系统网络提示消息 --
function Network.ShowSystemMessage(code,ishow)
	InfoCtrl.SetSystemType(1);
	InfoCtrl.OnInitData(code,ishow);
	Network.AwakePanel(CtrlNames.Info);
end

-- 显示系统通用提示消息 --
function Network.ShowSystemCodeMsg(code,ishowTxt,msg)
	InfoCtrl.SetSystemType(2);
	InfoCtrl.OnInitRollMsg(code,ishowTxt,msg);
	Network.AwakePanel(CtrlNames.Info);
end

-- 进入游戏场景，关闭所有面板 --
function Network.EnterGameClosePanel()
	SelectRoleCtrl.Close();
	--LoadResourceCtrl.Close();
	LoginCtrl.Close();
	MainCtrl.Close();
	MatchCtrl.Close();
end

function Network.MatchClosePanel()
	SelectRoleCtrl.Close();
	LoadResourceCtrl.Close();
	MatchCtrl.Close();
	if DataEntry.roleModel.SceneId <= 1 then
		Network.AwakePanel(CtrlNames.Main);
	end
end

function Network.ShowMatchedPanel()
	MatchCtrl.ShowMatchedPanel();
end

function Network.SwitchUser()
	Network.AwakePanel(CtrlNames.Login);
	MainCtrl.Close();
end

function Network.LoadResourceClose()
	LoadResourceCtrl.Close();
end

function Network.LoginResultActive(isActive)
	LoginCtrl.SetLoginBtnActive(isActive);
end

----------------------  ui  end  ----------------------

--异常断线--
function Network.OnException() 
    islogging = false; 
	logError("OnException------->>>>");
	if AppConst.iSwitchUser == false then
		networkMgr:ShowLoading(true);
		if DataEntry.roleModel.SceneId <= 1 then
			Network.ShowSystemMessage(1,true);
		end
		if timer1 == nil then
			timer1 = Timer.New(this.SendConnectServer, 6, -1, true);
			timer1:Start();
		end
	end
end

function Network.SetLogginValue(islogin)
	islogging = islogin;
	logWarn("SetLogginValue------->>>>");
end

function Network.SendConnectServer()
	if islogging == false and AppConst.iSwitchUser == false then
		logError("SendConnectServer------->>>>");
		networkMgr:SendGameConnect();
		if DataEntry.roleModel.SceneId <= 1 then
			Network.ShowSystemMessage(1,true);
		end
	end
end


--连接中断，或者被踢掉--
function Network.OnDisconnect() 
    islogging = false; 
    logError("OnDisconnect------->>>>");
end

--房间登录失败--
function Network.OnRoomLoginFaile()
	--[[local code = AppConst.ROOMLOGINCODE;
	local ctrl = CtrlManager.GetCtrl(CtrlNames.Message);
    if ctrl ~= nil then
		MessageCtrl.OpenMatchBattle(code)
        ctrl:Awake();
    end--]]
end

--房间登录超时--
function Network.OnRoomLoginTimeOut() 
   	logError("OnRoomLoginTimeOut------->>>>");
	if DataEntry.roleModel.SceneId > 1 then
		isDisconnect = true;
		Network.ShowSystemMessage(1,true);
	end
	
	--[[local ctrl = CtrlManager.GetCtrl(CtrlNames.Message);
    if ctrl ~= nil then
		--MessageCtrl.SetNetMsgError("房间登录超时!");
        ctrl:Awake();
    end--]]
end

--房间发送断开--
function Network.OnRoomSendDisConnect() 
   	logError("OnRoomSendDisConnect------->>>>");
	--[[local ctrl = CtrlManager.GetCtrl(CtrlNames.Message);
    if ctrl ~= nil then
		--MessageCtrl.SetNetMsgError("房间发送消息断开!");
        ctrl:Awake();
    end--]]
end

--房间接收断开--
function Network.OnRoomReceiveDisConnect() 
   	logError("OnRoomReceiveDisConnect------->>>>");
	--networkMgr:ShowLoading(true);
	if DataEntry.roleModel.SceneId > 1 then
		isDisconnect = true;
		Network.ShowSystemMessage(1,true);
	end
	
	--[[local ctrl = CtrlManager.GetCtrl(CtrlNames.Message);
    if ctrl ~= nil then
		MessageCtrl.SetNetMsgError("房间接收消息断开!");
        ctrl:Awake();
    end--]]
	
end

--战斗登录返回--
function Network.OnConnectBattle() 
   	logWarn("OnConnectBattle------->>>>");
	if DataEntry.roleModel.SceneId > 1 then
		if isDisconnect then
			isDisconnect = false;
			Network.ShowSystemMessage(2,false);--"服务器连接成功..."
		end
	end

	--Network.OnOpenMatchLoading()
end

--战斗异常断线--
function Network.OnBattleException() 
   	logError("OnBattleException------->>>>");
end

--战斗连接中断，或者被踢掉--
function Network.OnBattleDisconnect() 
    logError("OnBattleDisconnect------->>>>");
end

--登录返回--
function Network.OnMessage(buffer) 
	if TestProtoType == ProtocalType.BINARY then
		this.TestLoginBinary(buffer);
	end
	if TestProtoType == ProtocalType.PB_LUA then
		this.TestLoginPblua(buffer);
	end
	if TestProtoType == ProtocalType.PBC then
		this.TestLoginPbc(buffer);
	end
	if TestProtoType == ProtocalType.SPROTO then
		this.TestLoginSproto(buffer);
	end
	----------------------------------------------------
    local ctrl = CtrlManager.GetCtrl(CtrlNames.Message);
    if ctrl ~= nil then
        ctrl:Awake();
    end
    logWarn('OnMessage-------->>>');
end

--二进制登录--
function Network.TestLoginBinary(buffer)
	local protocal = buffer:ReadByte();
	local str = buffer:ReadString();
	log('TestLoginBinary: protocal:>'..protocal..' str:>'..str);
end

--PBLUA登录--
function Network.TestLoginPblua(buffer)
	local protocal = buffer:ReadByte();
	local data = buffer:ReadBuffer();

    local msg = login_pb.LoginResponse();
    msg:ParseFromString(data);
	log('TestLoginPblua: protocal:>'..protocal..' msg:>'..msg.id);
end

--PBC登录--
function Network.TestLoginPbc(buffer)
	local protocal = buffer:ReadByte();
	local data = buffer:ReadBuffer();

    local path = Util.DataPath.."lua/3rd/pbc/addressbook.pb";

    local addr = io.open(path, "rb")
    local buffer = addr:read "*a"
    addr:close()
    protobuf.register(buffer)
    local decode = protobuf.decode("tutorial.Person" , data)

    print(decode.name)
    print(decode.id)
    for _,v in ipairs(decode.phone) do
        print("\t"..v.number, v.type)
    end
	log('TestLoginPbc: protocal:>'..protocal);
end

--SPROTO登录--
function Network.TestLoginSproto(buffer)
	local protocal = buffer:ReadByte();
	local code = buffer:ReadBuffer();

    local sp = sproto.parse [[
    .Person {
        name 0 : string
        id 1 : integer
        email 2 : string

        .PhoneNumber {
            number 0 : string
            type 1 : integer
        }

        phone 3 : *PhoneNumber
    }

    .AddressBook {
        person 0 : *Person(id)
        others 1 : *Person
    }
    ]]
    local addr = sp:decode("AddressBook", code)
    print_r(addr)
	log('TestLoginSproto: protocal:>'..protocal);
end

--卸载网络监听--
function Network.Unload()
    Event.RemoveListener(Protocal.Connect);
    Event.RemoveListener(Protocal.Message);
    Event.RemoveListener(Protocal.Exception);
    Event.RemoveListener(Protocal.Disconnect);
    logWarn('Unload Network...');
end